//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// Id: PSIDetectorConstruction.hh,v 1.6 2006/01/15 15:38:14 Volnykh V.P. Exp 
// GEANT4 tag Name: geant4-08-00 
//
// $Id: PSIDetectorConstruction.hh,v 1.1.1.1 2004/12/06 10:36:47 ivana Exp $
// 

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#ifndef PSIDetectorConstruction_h
#define PSIDetectorConstruction_h 1

#include "G4VUserDetectorConstruction.hh"
#include "globals.hh"

class G4LogicalVolume;

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

class PSIDetectorConstruction : public G4VUserDetectorConstruction
{
  public:
  
    PSIDetectorConstruction();
   ~PSIDetectorConstruction();

  public:
     
     G4VPhysicalVolume* Construct();

  private:
     G4LogicalVolume*  FindVolume(const G4String& name) const;

     G4LogicalVolume*   logicWorld;    //pointer to the logical World
     G4LogicalVolume*   logicMWPC;     //pointer to the logical MWPC
     G4LogicalVolume*   logicPVET;     //pointer to the logical PVET
     G4LogicalVolume*   logicPV01;     //pointer to the logical PV01
     G4LogicalVolume*   logicPV02;     //pointer to the logical PV02
     G4LogicalVolume*   logicPV03;     //pointer to the logical PV03
     G4LogicalVolume*   logicPV04;     //pointer to the logical PV04
     G4LogicalVolume*   logicPV05;     //pointer to the logical PV05
     G4LogicalVolume*   logicPV06;     //pointer to the logical PV06
     G4LogicalVolume*   logicPV07;     //pointer to the logical PV07
     G4LogicalVolume*   logicPV08;     //pointer to the logical PV08
     G4LogicalVolume*   logicPV09;     //pointer to the logical PV09
     G4LogicalVolume*   logicPV10;     //pointer to the logical PV10
     G4LogicalVolume*   logicPV11;     //pointer to the logical PV11
     G4LogicalVolume*   logicPV12;     //pointer to the logical PV12
     G4LogicalVolume*   logicPV13;     //pointer to the logical PV13
     G4LogicalVolume*   logicPV14;     //pointer to the logical PV14
     G4LogicalVolume*   logicPV15;     //pointer to the logical PV15
     G4LogicalVolume*   logicPV16;     //pointer to the logical PV16
     G4LogicalVolume*   logicPV17;     //pointer to the logical PV17
     G4LogicalVolume*   logicPV18;     //pointer to the logical PV18
     G4LogicalVolume*   logicPV19;     //pointer to the logical PV19
     G4LogicalVolume*   logicPV20;     //pointer to the logical PV20
     G4LogicalVolume*   logicDEGR;     //pointer to the logical DEGR
     G4LogicalVolume*   logicTUBE;     //pointer to the logical TUBE
     G4LogicalVolume*   logicTBI1;     //pointer to the logical TBI1
     G4LogicalVolume*   logicTBI2;     //pointer to the logical TBI2
     G4LogicalVolume*   logicTBI3;     //pointer to the logical TBI3
     G4LogicalVolume*   logicTBI4;     //pointer to the logical TBI4
     G4LogicalVolume*   logicTBO1;     //pointer to the logical TBO1
     G4LogicalVolume*   logicTBO2;     //pointer to the logical TBO2
     G4LogicalVolume*   logicTBO3;     //pointer to the logical TBO3
     G4LogicalVolume*   logicTBO4;     //pointer to the logical TBO4
     G4LogicalVolume*   logicPEN1;     //pointer to the logical PEN1
     G4LogicalVolume*   logicPEN2;     //pointer to the logical PEN2     
     G4LogicalVolume*   logicPEN3;     //pointer to the logical PEN3
     G4LogicalVolume*   logicPEN4;     //pointer to the logical PEN4     
     G4LogicalVolume*   logicPEN5;     //pointer to the logical PEN5
     G4LogicalVolume*   logicHXA1;     //pointer to the logical HXA1     
     G4LogicalVolume*   logicHXA2;     //pointer to the logical HXA2     
     G4LogicalVolume*   logicHXA3;     //pointer to the logical HXA3     
     G4LogicalVolume*   logicHXA4;     //pointer to the logical HXA4     
     G4LogicalVolume*   logicHXA5;     //pointer to the logical HXA5     
     G4LogicalVolume*   logicHXA6;     //pointer to the logical HXA6
     G4LogicalVolume*   logicHXB1;     //pointer to the logical HXB1     
     G4LogicalVolume*   logicHXB2;     //pointer to the logical HXB2     
     G4LogicalVolume*   logicHXB3;     //pointer to the logical HXB3     
     G4LogicalVolume*   logicHXB4;     //pointer to the logical HXB4     
     G4LogicalVolume*   logicHXB5;     //pointer to the logical HXB5     
     G4LogicalVolume*   logicHXB6;     //pointer to the logical HXB6     
     G4LogicalVolume*   logicHXC1;     //pointer to the logical HXC1     
     G4LogicalVolume*   logicHXC2;     //pointer to the logical HXC2     
     G4LogicalVolume*   logicHXC3;     //pointer to the logical HXC3     
     G4LogicalVolume*   logicHXC4;     //pointer to the logical HXC4     
     G4LogicalVolume*   logicHXC5;     //pointer to the logical HXC5     
     G4LogicalVolume*   logicHXC6;     //pointer to the logical HXC6      
     G4LogicalVolume*   logicHXD1;     //pointer to the logical HXD1     
     G4LogicalVolume*   logicHXD2;     //pointer to the logical HXD2     
     G4LogicalVolume*   logicHXD3;     //pointer to the logical HXD3     
     G4LogicalVolume*   logicHXD4;     //pointer to the logical HXD4     
     G4LogicalVolume*   logicHXD5;     //pointer to the logical HXD5     
     G4LogicalVolume*   logicHXD6;     //pointer to the logical HXD6     
     G4LogicalVolume*   logicH1D1;     //pointer to the logical H1D1     
     G4LogicalVolume*   logicH1D2;     //pointer to the logical H1D2     
     G4LogicalVolume*   logicH1D3;     //pointer to the logical H1D3     
     G4LogicalVolume*   logicH1D4;     //pointer to the logical H1D4     
     G4LogicalVolume*   logicH2D1;     //pointer to the logical H2D1     
     G4LogicalVolume*   logicH2D2;     //pointer to the logical H2D2     
     G4LogicalVolume*   logicH2D3;     //pointer to the logical H2D3     
     G4LogicalVolume*   logicH2D4;     //pointer to the logical H2D4     
     G4LogicalVolume*   logicV1V1;     //pointer to the logical V1V1     
     G4LogicalVolume*   logicV1V2;     //pointer to the logical V1V2     
     G4LogicalVolume*   logicV1V3;     //pointer to the logical V1V3     
     G4LogicalVolume*   logicV1V4;     //pointer to the logical V1V4    
     G4LogicalVolume*   logicV2V1;     //pointer to the logical V2V1     
     G4LogicalVolume*   logicV2V2;     //pointer to the logical V2V2     
     G4LogicalVolume*   logicV2V3;     //pointer to the logical V2V3     
     G4LogicalVolume*   logicV2V4;     //pointer to the logical V2V4                            
};

#endif

