//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// $Id: PSIPhysicsList.hh,v 1.11 2003/09/15 15:38:14 maire Exp $
// GEANT4 tag $Name: geant4-07-01 $
//
// 

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#ifndef PSIPhysicsList_h
#define PSIPhysicsList_h 1

#include "G4VUserPhysicsList.hh"
#include "globals.hh"

class G4Cerenkov;
class G4Scintillation;
class G4OpAbsorption;
class G4OpRayleigh;
class G4OpBoundaryProcess;
class G4OpWLS;
//class PSIPhysicsListMessenger;

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

class PSIPhysicsList: public G4VUserPhysicsList
{
  public:
    PSIPhysicsList();
    virtual ~PSIPhysicsList();

  public:
    void ConstructParticle();
    void ConstructProcess();

    void SetCuts();
    
  // these methods Construct physics processes and register them
    void ConstructGeneral();
    void ConstructEM();
    void ConstructHad();
    void ConstructOp();
 //
    void  ConstructAllBosons();
    void  ConstructAllLeptons();
    void  ConstructAllMesons();
    void  ConstructAllBaryons();
    void  ConstructAllIons();
    void  ConstructAllShortLiveds();
    
    //for the Messenger
    //void SetVerbose(G4int);
    //void SetNbOfPhotonsCerenkov(G4int);
    
    
  private:
    G4int VerboseLevel;
    G4int OpVerbLevel;
    
    //G4double cutForGamma;
    //G4double cutForElectron;
    //G4double cutForPositron;
  
  private:
    G4Scintillation*     theScintillationProcess;
    G4Cerenkov*          theCerenkovProcess;
    G4OpAbsorption*      theAbsorptionProcess;
    G4OpRayleigh*        theRayleighScatteringProcess;
    G4OpBoundaryProcess* theBoundaryProcess;
    G4OpWLS*             theWLSProcess;
    
    //PSIPhysicsListMessenger* pMessenger;   
};    

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#endif



