//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// $Id: pibeta.cc,v 1.11 2006/01/28 15:56:59 Volnykh V.P. Exp $
// GEANT4 tag $Name: geant4-08-00 $
//
//
// -------------------------------------------------------------------

#include "PSIAnalysis.hh"
#include "globals.hh"
#include "G4Track.hh"
#include "G4ios.hh"
#include <fstream>
#include <iomanip>
#include <string>
#include "G4SteppingManager.hh"
#include "G4ThreeVector.hh"

#include "G4UnitsTable.hh"

G4int event = 0;
G4int decayevent = 0;
G4double ZERO =  0.0;
//G4double ONE = 1.0;
//G4double TWO = 2.0;
G4double THREE = 3.0;
G4double FOUR  = 4.0;
//G4double FIVE =  5.0;
//G4double SIX  =  6.0;


G4double EDEGR = 0.0;
G4double ETARGET = 0.0;
G4double EMWPC1 = 0.0;
G4double EMWPC2 = 0.0;
G4double EPV01 = 0.0;
G4double EPV02 = 0.0;
G4double EPV03 = 0.0;
G4double EPV04 = 0.0;
G4double EPV05 = 0.0;
G4double EPV06 = 0.0;
G4double EPV07 = 0.0;
G4double EPV08 = 0.0;
G4double EPV09 = 0.0;
G4double EPV10 = 0.0;
G4double EPV11 = 0.0;
G4double EPV12 = 0.0;
G4double EPV13 = 0.0;
G4double EPV14 = 0.0;
G4double EPV15 = 0.0;
G4double EPV16 = 0.0;
G4double EPV17 = 0.0;
G4double EPV18 = 0.0;
G4double EPV19 = 0.0;
G4double EPV20 = 0.0;
G4double EPENT_0 = 0.0;
G4double EPENT_1 = 0.0;
G4double EPENT_2 = 0.0;
G4double EPENT_3 = 0.0;
G4double EPENT_4 = 0.0;
G4double EPENT_5 = 0.0;
G4double EPENT_6 = 0.0;
G4double EPENT_7 = 0.0;
G4double EPENT_8 = 0.0;
G4double EPENT_9 = 0.0;
G4double EHEXA_0 = 0.0;
G4double EHEXA_1 = 0.0;
G4double EHEXA_2 = 0.0;
G4double EHEXA_3 = 0.0;
G4double EHEXA_4 = 0.0;
G4double EHEXA_5 = 0.0;
G4double EHEXA_6 = 0.0;
G4double EHEXA_7 = 0.0;
G4double EHEXA_8 = 0.0;
G4double EHEXA_9 = 0.0;
G4double EHEXA10 = 0.0;
G4double EHEXA11 = 0.0;
G4double EHEXA12 = 0.0;
G4double EHEXA13 = 0.0;
G4double EHEXA14 = 0.0;
G4double EHEXA15 = 0.0;
G4double EHEXA16 = 0.0;
G4double EHEXA17 = 0.0;
G4double EHEXA18 = 0.0;
G4double EHEXA19 = 0.0;
G4double EHEXA20 = 0.0;
G4double EHEXA21 = 0.0;
G4double EHEXA22 = 0.0;
G4double EHEXA23 = 0.0;
G4double EHEXA24 = 0.0;
G4double EHEXA25 = 0.0;
G4double EHEXA26 = 0.0;
G4double EHEXA27 = 0.0;
G4double EHEXA28 = 0.0;
G4double EHEXA29 = 0.0;
G4double EHEXA30 = 0.0;
G4double EHEXA31 = 0.0;
G4double EHEXA32 = 0.0;
G4double EHEXA33 = 0.0;
G4double EHEXA34 = 0.0;
G4double EHEXA35 = 0.0;
G4double EHEXA36 = 0.0;
G4double EHEXA37 = 0.0;
G4double EHEXA38 = 0.0;
G4double EHEXA39 = 0.0;
G4double EHEXA40 = 0.0;
G4double EHEXA41 = 0.0;
G4double EHEXA42 = 0.0;
G4double EHEXA43 = 0.0;
G4double EHEXA44 = 0.0;
G4double EHEXA45 = 0.0;
G4double EHEXA46 = 0.0;
G4double EHEXA47 = 0.0;
G4double EHEXA48 = 0.0;
G4double EHEXA49 = 0.0;
G4double EHEXB_0 = 0.0;
G4double EHEXB_1 = 0.0;
G4double EHEXB_2 = 0.0;
G4double EHEXB_3 = 0.0;
G4double EHEXB_4 = 0.0;
G4double EHEXB_5 = 0.0;
G4double EHEXB_6 = 0.0;
G4double EHEXB_7 = 0.0;
G4double EHEXB_8 = 0.0;
G4double EHEXB_9 = 0.0;
G4double EHEXB10 = 0.0;
G4double EHEXB11 = 0.0;
G4double EHEXB12 = 0.0;
G4double EHEXB13 = 0.0;
G4double EHEXB14 = 0.0;
G4double EHEXB15 = 0.0;
G4double EHEXB16 = 0.0;
G4double EHEXB17 = 0.0;
G4double EHEXB18 = 0.0;
G4double EHEXB19 = 0.0;
G4double EHEXB20 = 0.0;
G4double EHEXB21 = 0.0;
G4double EHEXB22 = 0.0;
G4double EHEXB23 = 0.0;
G4double EHEXB24 = 0.0;
G4double EHEXB25 = 0.0;
G4double EHEXB26 = 0.0;
G4double EHEXB27 = 0.0;
G4double EHEXB28 = 0.0;
G4double EHEXB29 = 0.0;
G4double EHEXB30 = 0.0;
G4double EHEXB31 = 0.0;
G4double EHEXB32 = 0.0;
G4double EHEXB33 = 0.0;
G4double EHEXB34 = 0.0;
G4double EHEXB35 = 0.0;
G4double EHEXB36 = 0.0;
G4double EHEXB37 = 0.0;
G4double EHEXB38 = 0.0;
G4double EHEXB39 = 0.0;
G4double EHEXB40 = 0.0;
G4double EHEXB41 = 0.0;
G4double EHEXB42 = 0.0;
G4double EHEXB43 = 0.0;
G4double EHEXB44 = 0.0;
G4double EHEXB45 = 0.0;
G4double EHEXB46 = 0.0;
G4double EHEXB47 = 0.0;
G4double EHEXB48 = 0.0;
G4double EHEXB49 = 0.0;
G4double EHEXC_0 = 0.0;
G4double EHEXC_1 = 0.0;
G4double EHEXC_2 = 0.0;
G4double EHEXC_3 = 0.0;
G4double EHEXC_4 = 0.0;
G4double EHEXC_5 = 0.0;
G4double EHEXC_6 = 0.0;
G4double EHEXC_7 = 0.0;
G4double EHEXC_8 = 0.0;
G4double EHEXC_9 = 0.0;
G4double EHEXC10 = 0.0;
G4double EHEXC11 = 0.0;
G4double EHEXC12 = 0.0;
G4double EHEXC13 = 0.0;
G4double EHEXC14 = 0.0;
G4double EHEXC15 = 0.0;
G4double EHEXC16 = 0.0;
G4double EHEXC17 = 0.0;
G4double EHEXC18 = 0.0;
G4double EHEXC19 = 0.0;
G4double EHEXC20 = 0.0;
G4double EHEXC21 = 0.0;
G4double EHEXC22 = 0.0;
G4double EHEXC23 = 0.0;
G4double EHEXC24 = 0.0;
G4double EHEXC25 = 0.0;
G4double EHEXC26 = 0.0;
G4double EHEXC27 = 0.0;
G4double EHEXC28 = 0.0;
G4double EHEXC29 = 0.0;
G4double EHEXC30 = 0.0;
G4double EHEXC31 = 0.0;
G4double EHEXC32 = 0.0;
G4double EHEXC33 = 0.0;
G4double EHEXC34 = 0.0;
G4double EHEXC35 = 0.0;
G4double EHEXC36 = 0.0;
G4double EHEXC37 = 0.0;
G4double EHEXC38 = 0.0;
G4double EHEXC39 = 0.0;
G4double EHEXC40 = 0.0;
G4double EHEXC41 = 0.0;
G4double EHEXC42 = 0.0;
G4double EHEXC43 = 0.0;
G4double EHEXC44 = 0.0;
G4double EHEXC45 = 0.0;
G4double EHEXC46 = 0.0;
G4double EHEXC47 = 0.0;
G4double EHEXC48 = 0.0;
G4double EHEXC49 = 0.0;
G4double EHEXD_0 = 0.0;
G4double EHEXD_1 = 0.0;
G4double EHEXD_2 = 0.0;
G4double EHEXD_3 = 0.0;
G4double EHEXD_4 = 0.0;
G4double EHEXD_5 = 0.0;
G4double EHEXD_6 = 0.0;
G4double EHEXD_7 = 0.0;
G4double EHEXD_8 = 0.0;
G4double EHEXD_9 = 0.0;
G4double EHEXD10 = 0.0;
G4double EHEXD11 = 0.0;
G4double EHEXD12 = 0.0;
G4double EHEXD13 = 0.0;
G4double EHEXD14 = 0.0;
G4double EHEXD15 = 0.0;
G4double EHEXD16 = 0.0;
G4double EHEXD17 = 0.0;
G4double EHEXD18 = 0.0;
G4double EHEXD19 = 0.0;
G4double EHEXD20 = 0.0;
G4double EHEXD21 = 0.0;
G4double EHEXD22 = 0.0;
G4double EHEXD23 = 0.0;
G4double EHEXD24 = 0.0;
G4double EHEXD25 = 0.0;
G4double EHEXD26 = 0.0;
G4double EHEXD27 = 0.0;
G4double EHEXD28 = 0.0;
G4double EHEXD29 = 0.0;
G4double EHEXD30 = 0.0;
G4double EHEXD31 = 0.0;
G4double EHEXD32 = 0.0;
G4double EHEXD33 = 0.0;
G4double EHEXD34 = 0.0;
G4double EHEXD35 = 0.0;
G4double EHEXD36 = 0.0;
G4double EHEXD37 = 0.0;
G4double EHEXD38 = 0.0;
G4double EHEXD39 = 0.0;
G4double EHH1D_0 = 0.0;
G4double EHH1D_1 = 0.0;
G4double EHH1D_2 = 0.0;
G4double EHH1D_3 = 0.0;
G4double EHH1D_4 = 0.0;
G4double EHH1D_5 = 0.0;
G4double EHH1D_6 = 0.0;
G4double EHH1D_7 = 0.0;
G4double EHH1D_8 = 0.0;
G4double EHH1D_9 = 0.0;
G4double EHH2D_0 = 0.0;
G4double EHH2D_1 = 0.0;
G4double EHH2D_2 = 0.0;
G4double EHH2D_3 = 0.0;
G4double EHH2D_4 = 0.0;
G4double EHH2D_5 = 0.0;
G4double EHH2D_6 = 0.0;
G4double EHH2D_7 = 0.0;
G4double EHH2D_8 = 0.0;
G4double EHH2D_9 = 0.0;
G4double EVT1V_0 = 0.0;
G4double EVT1V_1 = 0.0;
G4double EVT1V_2 = 0.0;
G4double EVT1V_3 = 0.0;
G4double EVT1V_4 = 0.0;
G4double EVT1V_5 = 0.0;
G4double EVT1V_6 = 0.0;
G4double EVT1V_7 = 0.0;
G4double EVT1V_8 = 0.0;
G4double EVT1V_9 = 0.0;
G4double EVT2V_0 = 0.0;
G4double EVT2V_1 = 0.0;
G4double EVT2V_2 = 0.0;
G4double EVT2V_3 = 0.0;
G4double EVT2V_4 = 0.0;
G4double EVT2V_5 = 0.0;
G4double EVT2V_6 = 0.0;
G4double EVT2V_7 = 0.0;
G4double EVT2V_8 = 0.0;
G4double EVT2V_9 = 0.0;



// Quantities for the ntuple
G4double deKin;
G4double eKin;
G4double x;
G4double y;
G4double z;
G4double xpre;
G4double ypre;
G4double zpre;
G4double xpost;
G4double ypost;
G4double zpost;
G4double dirX;
G4double dirY;
G4double dirZ;
G4double vertexeKin;
G4double vertexx;
G4double vertexy;
G4double vertexz;
G4double vertexdirX;
G4double vertexdirY;
G4double vertexdirZ;
G4double timepre;
G4double timepost; 


G4int ID;
G4int IDCURRENT;
G4int PIDCURRENT; 
G4int PRTCL = 0;

G4int WHERE = 0;

G4double GAS1lx = 0.0;
G4double GAS1ly = 0.0; 
G4double GAS1lz = 0.0;
G4double GAS1rx = 0.0;
G4double GAS1ry = 0.0; 
G4double GAS1rz = 0.0;
G4double GAS1x = 0.0;
G4double GAS1y = 0.0; 
G4double GAS1z = 0.0;
G4double GAS1dirx = 0.0;
G4double GAS1diry = 0.0;
G4double GAS1dirz = 0.0;
G4double GAS1count = 0.0;
G4double GAS1enrg = 0.0;
G4double GAS1denrg = 0.0;
G4double GAS1ltime = 0.0;
G4double GAS1rtime = 0.0;
G4double GAS1time = 0.0;

G4double GAS2lx = 0.0;
G4double GAS2ly = 0.0; 
G4double GAS2lz = 0.0;
G4double GAS2rx = 0.0;
G4double GAS2ry = 0.0; 
G4double GAS2rz = 0.0;
G4double GAS2x = 0.0;
G4double GAS2y = 0.0; 
G4double GAS2z = 0.0;
G4double GAS2dirx = 0.0;
G4double GAS2diry = 0.0;
G4double GAS2dirz = 0.0;
G4double GAS2count = 0.0;
G4double GAS2enrg = 0.0;
G4double GAS2denrg = 0.0;
G4double GAS2ltime = 0.0;
G4double GAS2rtime = 0.0;
G4double GAS2time = 0.0;

G4double PVETlx = 0.0;
G4double PVETly = 0.0; 
G4double PVETlz = 0.0;
G4double PVETrx = 0.0;
G4double PVETry = 0.0; 
G4double PVETrz = 0.0;
G4double PVETx = 0.0;
G4double PVETy = 0.0; 
G4double PVETz = 0.0;
G4double PVETdirx = 0.0;
G4double PVETdiry = 0.0;
G4double PVETdirz = 0.0;
G4double PVETcount = 0.0;
G4double PVETenrg = 0.0;
G4double PVETdenrg = 0.0;
G4double PVETltime = 0.0;
G4double PVETrtime = 0.0;
G4double PVETtime = 0.0;

G4double csix = 0.0;
G4double csiy = 0.0; 
G4double csiz = 0.0;
G4double csidirx = 0.0;
G4double csidiry = 0.0; 
G4double csidirz = 0.0;
G4double csienrg = 0.0;
G4double csidenrg = 0.0;
G4double csitime = 0.0;

G4double volume;

using namespace std;

string vsubstr1;
string vsubstr2;
string vsubstr3;
string vsubstr4;
string vsubstr6;
string vvertex;
string vcsi;
string particle;
string process;
string nextvol;



PSIAnalysis* PSIAnalysis::instance = 0;

PSIAnalysis::PSIAnalysis()
#ifdef G4ANALYSIS_USE
  : analysisFactory(0)
  , tree(0)
  , histoFactory(0)
    , tupleFactory(0), ntuple100(0), ntuple101(0)
//    , tupleFactory(0), h1(0), h2(0), h3(0), ntuple100(0), ntuple101(0)
// #ifdef G4ANALYSIS_USE_PLOTTER
//   , plotterFactory(0)
//   , plotter(0)
// #endif
#endif
{
//#ifdef G4ANALYSIS_USE
  histFileName = "events";
  histFileType = "root";
// histFileType = "hbook";
//#endif

//  asciiFileName="xraytel.out";
//  std::ofstream asciiFile(asciiFileName, std::ios::app);
//  if(asciiFile.is_open()) {
//    asciiFile << "Energy (keV)  x (mm)    y (mm)    z (mm)" << G4endl << G4endl;

}

PSIAnalysis::~PSIAnalysis()
{ 
#ifdef G4ANALYSIS_USE

// #ifdef G4ANALYSIS_USE_PLOTTER
//   if (plotterFactory) delete plotterFactory;
//   plotterFactory = 0;
// #endif

  if (tupleFactory) delete tupleFactory;
  tupleFactory = 0;

  if (histoFactory) delete histoFactory;
  histoFactory = 0;

  if (tree) delete tree;
  tree = 0;

  if (analysisFactory) delete analysisFactory;
  analysisFactory = 0;
#endif
}

PSIAnalysis* PSIAnalysis::getInstance()
{
  if (instance == 0) instance = new PSIAnalysis;
  return instance;
}


void PSIAnalysis::book()
{
#ifdef G4ANALYSIS_USE
  //build up  the  factories
  analysisFactory = AIDA_createAnalysisFactory();
  if(analysisFactory) {
    //parameters for the TreeFactory
    G4bool fileExists = true;
    G4bool readOnly   = false;
    AIDA::ITreeFactory* treeFactory = analysisFactory->createTreeFactory();
    if(treeFactory) {
      G4String histFileNameComplete;
      histFileNameComplete = histFileName+".root";
//      histFileNameComplete = histFileName+".hbook";
      tree = treeFactory->create(histFileNameComplete, "root", readOnly, fileExists);
//      tree = treeFactory->create(histFileNameComplete, "hbook", readOnly, fileExists);
      G4cout << " Histogramfile: " << histFileNameComplete << G4endl;
      
      if (tree) {
    G4cout << "Tree store : " << tree->storeName() << G4endl;
    G4cout << "Booked Hbook ROOT File " << G4endl;

//  HistoFactory and TupleFactory depend on theTree
    //histoFactory = analysisFactory->createHistogramFactory ( *tree );
    tupleFactory = analysisFactory->createTupleFactory     ( *tree );

    // Book histograms
//  h1 = histoFactory->createHistogram1D("1","PI+ Primary energy distribution /keV", 20000,-410000.,410000.);
//  h1 = histoFactory->createHistogram1D("1","PI+ Decay,x-projection /mm", 20000,-30.,30.);
//  h2 = histoFactory->createHistogram1D("2","PI+ Decay,y-projection /mm", 20000,-30.,30.);
//  h3 = histoFactory->createHistogram1D("3","PI+ Decay,z-projection /mm", 20000,-63.83,30.);
//  h4 = histoFactory->createHistogram2D("4","y-z, entering detector /mm", 200,-50.,50.,200,-50.,50.);

    // Book ntuples
    ntuple100 = tupleFactory->create( "100", "PI+,Primary decay_energy distributions /MeV",
      "double event,btstop,\
       xin,yin,zin,ein,\
       xdc,ydc,zdc,timedcpre,timedcpost,\
       xmdc,ymdc,zmdc,timemdcpre,timemdcpost,\
       degr,target,\
       mwpc1,mwpc2,\
       pv01,pv02,pv03,pv04,pv05,pv06,pv07,pv08,pv09,pv10,\
       pv11,pv12,pv13,pv14,pv15,pv16,pv17,pv18,pv19,pv20,\
       pent_0,pent_1,pent_2,pent_3,pent_4,pent_5,pent_6,pent_7,pent_8,pent_9,\
       hexa_0,hexa_1,hexa_2,hexa_3,hexa_4,hexa_5,hexa_6,hexa_7,hexa_8,hexa_9,\
       hexa10,hexa11,hexa12,hexa13,hexa14,hexa15,hexa16,hexa17,hexa18,hexa19,\
       hexa20,hexa21,hexa22,hexa23,hexa24,hexa25,hexa26,hexa27,hexa28,hexa29,\
       hexa30,hexa31,hexa32,hexa33,hexa34,hexa35,hexa36,hexa37,hexa38,hexa39,\
       hexa40,hexa41,hexa42,hexa43,hexa44,hexa45,hexa46,hexa47,hexa48,hexa49,\
       hexb_0,hexb_1,hexb_2,hexb_3,hexb_4,hexb_5,hexb_6,hexb_7,hexb_8,hexb_9,\
       hexb10,hexb11,hexb12,hexb13,hexb14,hexb15,hexb16,hexb17,hexb18,hexb19,\
       hexb20,hexb21,hexb22,hexb23,hexb24,hexb25,hexb26,hexb27,hexb28,hexb29,\
       hexb30,hexb31,hexb32,hexb33,hexb34,hexb35,hexb36,hexb37,hexb38,hexb39,\
       hexb40,hexb41,hexb42,hexb43,hexb44,hexb45,hexb46,hexb47,hexb48,hexb49,\
       hexc_0,hexc_1,hexc_2,hexc_3,hexc_4,hexc_5,hexc_6,hexc_7,hexc_8,hexc_9,\
       hexc10,hexc11,hexc12,hexc13,hexc14,hexc15,hexc16,hexc17,hexc18,hexc19,\
       hexc20,hexc21,hexc22,hexc23,hexc24,hexc25,hexc26,hexc27,hexc28,hexc29,\
       hexc30,hexc31,hexc32,hexc33,hexc34,hexc35,hexc36,hexc37,hexc38,hexc39,\
       hexc40,hexc41,hexc42,hexc43,hexc44,hexc45,hexc46,hexc47,hexc48,hexc49,\
       hexd_0,hexd_1,hexd_2,hexd_3,hexd_4,hexd_5,hexd_6,hexd_7,hexd_8,hexd_9,\
       hexd10,hexd11,hexd12,hexd13,hexd14,hexd15,hexd16,hexd17,hexd18,hexd19,\
       hexd20,hexd21,hexd22,hexd23,hexd24,hexd25,hexd26,hexd27,hexd28,hexd29,\
       hexd30,hexd31,hexd32,hexd33,hexd34,hexd35,hexd36,hexd37,hexd38,hexd39,\
       hh1d_0,hh1d_1,hh1d_2,hh1d_3,hh1d_4,hh1d_5,hh1d_6,hh1d_7,hh1d_8,hh1d_9,\
       hh2d_0,hh2d_1,hh2d_2,hh2d_3,hh2d_4,hh2d_5,hh2d_6,hh2d_7,hh2d_8,hh2d_9,\
       vt1v_0,vt1v_1,vt1v_2,vt1v_3,vt1v_4,vt1v_5,vt1v_6,vt1v_7,vt1v_8,vt1v_9,\
       vt2v_0,vt2v_1,vt2v_2,vt2v_3,vt2v_4,vt2v_5,vt2v_6,vt2v_7,vt2v_8,vt2v_9" );
                
    ntuple101 = tupleFactory->create( "101", "particles distributions ",
                "double event,id,pid,particle,vol,x,y,z,\
                dirx,diry,dirz,enrg,denrg,time" );
        
                         
//                ntuples

// event - number of Event

// btstop = 1, PI+ Decay in DEGR
//        = 2, PI+ Decay in TARGET
//        = 3, Rest
// xin - x-coordinate PI+ gun/posilion
// yin - y-coordinate PI+ gun/posilion
// zin - z-coordinate PI+ gun/posilion
// ein - energy PI+ in gun/position
// xdc - x-coordinate PI+ decay
// ydc - y-coordinate PI+ decay
// zdc - z-coordinate PI+ decay
// timedcpre -  begin Global time of PI+ decay
// timedcpost - end time of PI+ decay
// xmdc - x-coordinate mu+ decay
// ymdc - y-coordinate mu+ decay
// zmdc - z-coordinate mu+ decay
// timemdcpre  - begin Global time of mu+ decay
// timemdcpost - end time of mu+ decay 
// degr  - energy deposit in DECR
// target  - energy deposit in TARGET
// mpwc1  - energy deposit in MWPC1 
// mpwc2  - energy deposit in MWPC2
// pv01-pv20  - energy deposit in PV0I (PV01-PV20)
// 
//
//                   CSI
//
// EPENT_0 - EPENT_9 - energy deposit in PENT (PENT_0-PENT_9)
// EHEXA_0 - EHEXA49 - energy deposit in HEXA (HEXA_0-HEXA49)
// EHEXB_0 - EHEXB49 - energy deposit in HEXB (HEXB_0-HEXB49)
// EHEXC_0 - EHEXC49 - energy deposit in HEXC (HEXC_0-HEXC49)
// EHEXD_0 - EHEXD39 - energy deposit in HEXD (HEXD_0-HEXD39)
// EHH1D_0 - EHH1D_9 - energy deposit in HH1D (HH1D_0-HH1D_9)
// EHH2D_0 - EHH2D_9 - energy deposit in HH1D (HH1D_0-HH1D_9)
// EVT1V_0 - EVT1V_9 - energy deposit in VT1V (VT1V_0-VT1V_9)
// EVT2V_0 - EVT2V_9 - energy deposit in VT2V (VT2V_0-VT2V_9)



//                tracks 

// id    - track id number
// pid   - track id number of the parent

// PRTCL - particle name = 1 - pi+
//                       = 2 - mu+
//                       = 3 - e+
//                       = 4 - e-
//                       = 5 - gamma
//                       = 6 - proton
//                       = 7 - triton
//                       = 8 - alpha
//                       = 9 - pi0
//                       = 10 - Cs133[0.0]
//                       = 11 - I127[0.0] 
//                       = 12 - other

// vol          < 0, vertex position of particle ( = -1 - DEGR, = -2 - TARGET, -3 - other )  
//              = 3,  mwpc1  position of particle                                        
//              = 4,  mwpc2  position of particle
//              = 100+i,  pvi   position of particle
//              = 200+volume.substr(4,2),  csi    position of particle

// x,y,z - (x,y,z) of particle
// dirx,diry,dirz - particle MomentumDirection(init vector) 
// enrg  - kinetic energy of particle
// denrg - partice energy deposited
// time  - Global time (time from pi+ started)


    }
      delete treeFactory;
    }
  }
#endif

}

void PSIAnalysis::finish()
{
#ifdef G4ANALYSIS_USE
  if (tree) {
    // Committing the transaction with the tree
    G4cout << "Committing..." << G4endl;
    // write all histograms to file
    tree->commit();

    G4cout << "Closing the tree..." << G4endl;

    // close (will again commit)
    tree->close();
  }

  // extra delete as objects are created in book() method rather than during
  // initialisation of class

// #ifdef G4ANALYSIS_USE_PLOTTER
//   if (plotterFactory)  delete plotterFactory;
// #endif

  if (tupleFactory)    delete tupleFactory;
  if (histoFactory)    delete histoFactory;
  if (tree)            delete tree;
  if (analysisFactory) delete analysisFactory;
#endif
}

void PSIAnalysis::analyseStepping(const G4Step* aStep)
{
  const G4Track* track = aStep->GetTrack();
  eKin = track->GetKineticEnergy();
  //deKin = aStep->GetTotalEnergyDeposit()/keV;
  deKin = aStep->GetTotalEnergyDeposit();
  particle = track->GetDefinition()->GetParticleName();
  process = aStep->GetPostStepPoint()->GetProcessDefinedStep()->GetProcessName();
  ID = track->GetTrackID();
  
#ifdef G4ANALYSIS_USE


  G4ThreeVector pospre = aStep->GetPreStepPoint()->GetPosition();
  xpre = pospre.x();
  ypre = pospre.y();
  zpre = pospre.z();
  G4ThreeVector pospost = aStep->GetPreStepPoint()->GetPosition();
  xpost = pospost.x();
  ypost = pospost.y();
  zpost = pospost.z();  
  G4ThreeVector pos = track->GetPosition();
  x = pos.x();
  y = pos.y();
  z = pos.z();
  G4ThreeVector dir = track->GetMomentumDirection();
  dirX = dir.x();
  dirY = dir.y();
  dirZ = dir.z();
  //G4double time = aStep->GetPreStepPoint()->GetGlobalTime() ;
  //G4double time = track->GetGlobalTime() ;
  timepre =  aStep->GetPreStepPoint()->GetGlobalTime();
  timepost =  aStep->GetPostStepPoint()->GetGlobalTime(); 
  
  vsubstr1 = (track->GetVolume()->GetName()).substr(0,1);
  vsubstr2 = (track->GetVolume()->GetName()).substr(0,2);
  vsubstr3 = (track->GetVolume()->GetName()).substr(0,3);
  vsubstr4 = (track->GetVolume()->GetName()).substr(0,4);
  vsubstr6 = (track->GetVolume()->GetName()).substr(0,6);
  
  if (track->GetNextVolume())  {
  nextvol  = track->GetNextVolume()->GetName();
  } else {
  nextvol = "OutOfWorld"; 
   } 

  //if ((x > -25.) && (x < 25.) && (y > -25.) && (y < 25.) && (z > -63.83) && (z < 25.)) {

   if (track->GetVolume()) {
       if ((process == "Decay") &&
          (particle == "pi+")) {
    { 
      ntuple100->fill( ntuple100->findColumn( "xdc"       ), (G4double) x );
      ntuple100->fill( ntuple100->findColumn( "ydc"       ), (G4double) y );
      ntuple100->fill( ntuple100->findColumn( "zdc"       ), (G4double) z );
      ntuple100->fill( ntuple100->findColumn( "timedcpre" ), (G4double) timepre );
      ntuple100->fill( ntuple100->findColumn( "timedcpost"), (G4double) timepost );           
        if (vsubstr4 == "DEGR") {
            decayevent = 1;
    } else         
       if (vsubstr1 == "T")
          {
             decayevent = 2;
            } 
      }
     }   else
       if ((process == "Decay") &&
          (particle == "mu+")) {
      ntuple100->fill( ntuple100->findColumn( "xmdc"       ), (G4double) x );
      ntuple100->fill( ntuple100->findColumn( "ymdc"       ), (G4double) y );
      ntuple100->fill( ntuple100->findColumn( "zmdc"       ), (G4double) z );
      ntuple100->fill( ntuple100->findColumn( "timemdcpre" ), (G4double) timepre );
      ntuple100->fill( ntuple100->findColumn( "timemdcpost"), (G4double) timepost );   
     }   else
      if (vsubstr4 == "DEGR") {
        EDEGR = EDEGR + deKin;
    }  else
      if (vsubstr1 == "T")    {
        ETARGET = ETARGET + deKin;
    }  else
      if (vsubstr4 == "GAS1") {
        EMWPC1 = EMWPC1 + deKin;
    }  else
      if (vsubstr4 == "GAS2") {
        EMWPC2 = EMWPC2 + deKin;
    }  else
      if (vsubstr4 == "PV01") {
        EPV01 = EPV01 + deKin;
    }  else      
      if (vsubstr4 == "PV02") {
        EPV02 = EPV02 + deKin;
    }  else
      if (vsubstr4 == "PV03") {
        EPV03 = EPV03 + deKin;
    }  else
      if (vsubstr4 == "PV04") {
        EPV04 = EPV04 + deKin;
    }  else
      if (vsubstr4 == "PV05") {
        EPV05 = EPV05 + deKin;
    }  else
      if (vsubstr4 == "PV06") {
        EPV06 = EPV06 + deKin;
    }  else
      if (vsubstr4 == "PV07") {
        EPV07 = EPV07 + deKin;
    }  else
      if (vsubstr4 == "PV08") {
        EPV08 = EPV08 + deKin;
    }  else
      if (vsubstr4 == "PV09") {
        EPV09 = EPV09 + deKin;
    }  else
      if (vsubstr4 == "PV10") {
        EPV10 = EPV10 + deKin;
    }  else
      if (vsubstr4 == "PV11") {
        EPV11 = EPV11 + deKin;
    }  else      
      if (vsubstr4 == "PV12") {
        EPV12 = EPV12 + deKin;
    }  else
      if (vsubstr4 == "PV13") {
        EPV13 = EPV13 + deKin;
    }  else
      if (vsubstr4 == "PV14") {
        EPV14 = EPV14 + deKin;
    }  else
      if (vsubstr4 == "PV15") {
        EPV15 = EPV15 + deKin;
    }  else
      if (vsubstr4 == "PV16") {
        EPV16 = EPV16 + deKin;
    }  else
      if (vsubstr4 == "PV17") {
        EPV17 = EPV17 + deKin;
    }  else
      if (vsubstr4 == "PV18") {
        EPV18 = EPV18 + deKin;
    }  else
      if (vsubstr4 == "PV19") {
        EPV19 = EPV19 + deKin;
    }  else
      if (vsubstr4 == "PV20") {
        EPV20 = EPV20 + deKin;                                                                       
    }  else
      if (vsubstr6 == "PENT_0") {
        EPENT_0 = EPENT_0 + deKin;
    }  else
      if (vsubstr6 == "PENT_1") {
        EPENT_1 = EPENT_1 + deKin;
    }  else
      if (vsubstr6 == "PENT_2") {
        EPENT_2 = EPENT_2 + deKin;
    }  else
      if (vsubstr6 == "PENT_3") {
        EPENT_3 = EPENT_3 + deKin;        
    }  else
      if (vsubstr6 == "PENT_4") {
        EPENT_4 = EPENT_4 + deKin;        
    }  else
      if (vsubstr6 == "PENT_5") {
        EPENT_5 = EPENT_5 + deKin;        
    }  else
      if (vsubstr6 == "PENT_6") {
        EPENT_6 = EPENT_6 + deKin;        
    }  else
      if (vsubstr6 == "PENT_7") {
        EPENT_7 = EPENT_7 + deKin;        
    }  else
      if (vsubstr6 == "PENT_8") {
        EPENT_8 = EPENT_8 + deKin;        
    }  else
      if (vsubstr6 == "PENT_9") {
        EPENT_9 = EPENT_9 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_0") {
        EHEXA_0 = EHEXA_0 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_1") {
        EHEXA_1 = EHEXA_1 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_2") {
        EHEXA_2 = EHEXA_2 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_3") {
        EHEXA_3 = EHEXA_3 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_4") {
        EHEXA_4 = EHEXA_4 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_5") {
        EHEXA_5 = EHEXA_5 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_6") {
        EHEXA_6 = EHEXA_6 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_7") {
        EHEXA_7 = EHEXA_7 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_8") {
        EHEXA_8 = EHEXA_8 + deKin;        
    }  else
      if (vsubstr6 == "HEXA_9") {
        EHEXA_9 = EHEXA_9 + deKin;        
    }  else
      if (vsubstr6 == "HEXA10") {
        EHEXA10 = EHEXA10 + deKin;        
    }  else
      if (vsubstr6 == "HEXA11") {
        EHEXA11 = EHEXA11 + deKin;        
    }  else
      if (vsubstr6 == "HEXA12") {
        EHEXA12 = EHEXA12 + deKin;        
    }  else
      if (vsubstr6 == "HEXA13") {
        EHEXA13 = EHEXA13 + deKin;        
    }  else
      if (vsubstr6 == "HEXA14") {
        EHEXA14 = EHEXA14 + deKin;        
    }  else
      if (vsubstr6 == "HEXA15") {
        EHEXA15 = EHEXA15 + deKin;        
    }  else
      if (vsubstr6 == "HEXA16") {
        EHEXA16 = EHEXA16 + deKin;        
    }  else
      if (vsubstr6 == "HEXA17") {
        EHEXA17 = EHEXA17 + deKin;        
    }  else
      if (vsubstr6 == "HEXA18") {
        EHEXA18 = EHEXA18 + deKin;        
    }  else
      if (vsubstr6 == "HEXA19") {
        EHEXA19 = EHEXA19 + deKin;         
    }  else
      if (vsubstr6 == "HEXA20") {
        EHEXA20 = EHEXA20 + deKin;        
    }  else
      if (vsubstr6 == "HEXA21") {
        EHEXA21 = EHEXA21 + deKin;        
    }  else
      if (vsubstr6 == "HEXA22") {
        EHEXA22 = EHEXA22 + deKin;        
    }  else
      if (vsubstr6 == "HEXA23") {
        EHEXA23 = EHEXA23 + deKin;        
    }  else
      if (vsubstr6 == "HEXA24") {
        EHEXA24 = EHEXA24 + deKin;        
    }  else
      if (vsubstr6 == "HEXA25") {
        EHEXA25 = EHEXA25 + deKin;        
    }  else
      if (vsubstr6 == "HEXA26") {
        EHEXA26 = EHEXA26 + deKin;        
    }  else
      if (vsubstr6 == "HEXA27") {
        EHEXA27 = EHEXA27 + deKin;        
    }  else
      if (vsubstr6 == "HEXA28") {
        EHEXA28 = EHEXA28 + deKin;        
    }  else
      if (vsubstr6 == "HEXA29") {
        EHEXA29 = EHEXA29 + deKin;         
    }  else
      if (vsubstr6 == "HEXA30") {
        EHEXA30 = EHEXA30 + deKin;        
    }  else
      if (vsubstr6 == "HEXA31") {
        EHEXA31 = EHEXA31 + deKin;        
    }  else
      if (vsubstr6 == "HEXA32") {
        EHEXA32 = EHEXA32 + deKin;        
    }  else
      if (vsubstr6 == "HEXA33") {
        EHEXA33 = EHEXA33 + deKin;        
    }  else
      if (vsubstr6 == "HEXA34") {
        EHEXA34 = EHEXA34 + deKin;        
    }  else
      if (vsubstr6 == "HEXA35") {
        EHEXA35 = EHEXA35 + deKin;        
    }  else
      if (vsubstr6 == "HEXA36") {
        EHEXA36 = EHEXA36 + deKin;        
    }  else
      if (vsubstr6 == "HEXA37") {
        EHEXA37 = EHEXA37 + deKin;        
    }  else
      if (vsubstr6 == "HEXA38") {
        EHEXA38 = EHEXA38 + deKin;        
    }  else
      if (vsubstr6 == "HEXA39") {
        EHEXA39 = EHEXA39 + deKin;         
    }  else
      if (vsubstr6 == "HEXA40") {
        EHEXA40 = EHEXA40 + deKin;        
    }  else
      if (vsubstr6 == "HEXA41") {
        EHEXA41 = EHEXA41 + deKin;        
    }  else
      if (vsubstr6 == "HEXA42") {
        EHEXA42 = EHEXA42 + deKin;        
    }  else
      if (vsubstr6 == "HEXA43") {
        EHEXA43 = EHEXA43 + deKin;        
    }  else
      if (vsubstr6 == "HEXA44") {
        EHEXA44 = EHEXA44 + deKin;        
    }  else
      if (vsubstr6 == "HEXA45") {
        EHEXA45 = EHEXA45 + deKin;        
    }  else
      if (vsubstr6 == "HEXA46") {
        EHEXA46 = EHEXA46 + deKin;        
    }  else
      if (vsubstr6 == "HEXA47") {
        EHEXA47 = EHEXA47 + deKin;        
    }  else
      if (vsubstr6 == "HEXA48") {
        EHEXA48 = EHEXA48 + deKin;        
    }  else
      if (vsubstr6 == "HEXA49") {
        EHEXA49 = EHEXA49 + deKin;
    }  else          
      if (vsubstr6 == "HEXB_0") {
        EHEXB_0 = EHEXB_0 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_1") {
        EHEXB_1 = EHEXB_1 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_2") {
        EHEXB_2 = EHEXB_2 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_3") {
        EHEXB_3 = EHEXB_3 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_4") {
        EHEXB_4 = EHEXB_4 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_5") {
        EHEXB_5 = EHEXB_5 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_6") {
        EHEXB_6 = EHEXB_6 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_7") {
        EHEXB_7 = EHEXB_7 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_8") {
        EHEXB_8 = EHEXB_8 + deKin;        
    }  else
      if (vsubstr6 == "HEXB_9") {
        EHEXB_9 = EHEXB_9 + deKin;        
    }  else
      if (vsubstr6 == "HEXB10") {
        EHEXB10 = EHEXB10 + deKin;        
    }  else
      if (vsubstr6 == "HEXB11") {
        EHEXB11 = EHEXB11 + deKin;        
    }  else
      if (vsubstr6 == "HEXB12") {
        EHEXB12 = EHEXB12 + deKin;        
    }  else
      if (vsubstr6 == "HEXB13") {
        EHEXB13 = EHEXB13 + deKin;        
    }  else
      if (vsubstr6 == "HEXB14") {
        EHEXB14 = EHEXB14 + deKin;        
    }  else
      if (vsubstr6 == "HEXB15") {
        EHEXB15 = EHEXB15 + deKin;        
    }  else
      if (vsubstr6 == "HEXB16") {
        EHEXB16 = EHEXB16 + deKin;        
    }  else
      if (vsubstr6 == "HEXB17") {
        EHEXB17 = EHEXB17 + deKin;        
    }  else
      if (vsubstr6 == "HEXB18") {
        EHEXB18 = EHEXB18 + deKin;        
    }  else
      if (vsubstr6 == "HEXB19") {
        EHEXB19 = EHEXB19 + deKin;         
    }  else
      if (vsubstr6 == "HEXB20") {
        EHEXB20 = EHEXB20 + deKin;        
    }  else
      if (vsubstr6 == "HEXB21") {
        EHEXB21 = EHEXB21 + deKin;        
    }  else
      if (vsubstr6 == "HEXB22") {
        EHEXB22 = EHEXB22 + deKin;        
    }  else
      if (vsubstr6 == "HEXB23") {
        EHEXB23 = EHEXB23 + deKin;        
    }  else
      if (vsubstr6 == "HEXB24") {
        EHEXB24 = EHEXB24 + deKin;        
    }  else
      if (vsubstr6 == "HEXB25") {
        EHEXB25 = EHEXB25 + deKin;        
    }  else
      if (vsubstr6 == "HEXB26") {
        EHEXB26 = EHEXB26 + deKin;        
    }  else
      if (vsubstr6 == "HEXB27") {
        EHEXB27 = EHEXB27 + deKin;        
    }  else
      if (vsubstr6 == "HEXB28") {
        EHEXB28 = EHEXB28 + deKin;        
    }  else
      if (vsubstr6 == "HEXB29") {
        EHEXB29 = EHEXB29 + deKin;         
    }  else
      if (vsubstr6 == "HEXB30") {
        EHEXB30 = EHEXB30 + deKin;        
    }  else
      if (vsubstr6 == "HEXB31") {
        EHEXB31 = EHEXB31 + deKin;        
    }  else
      if (vsubstr6 == "HEXB32") {
        EHEXB32 = EHEXB32 + deKin;        
    }  else
      if (vsubstr6 == "HEXB33") {
        EHEXB33 = EHEXB33 + deKin;        
    }  else
      if (vsubstr6 == "HEXB34") {
        EHEXB34 = EHEXB34 + deKin;        
    }  else
      if (vsubstr6 == "HEXB35") {
        EHEXB35 = EHEXB35 + deKin;        
    }  else
      if (vsubstr6 == "HEXB36") {
        EHEXB36 = EHEXB36 + deKin;        
    }  else
      if (vsubstr6 == "HEXB37") {
        EHEXB37 = EHEXB37 + deKin;        
    }  else
      if (vsubstr6 == "HEXB38") {
        EHEXB38 = EHEXB38 + deKin;        
    }  else
      if (vsubstr6 == "HEXB39") {
        EHEXB39 = EHEXB39 + deKin;         
    }  else
      if (vsubstr6 == "HEXB40") {
        EHEXB40 = EHEXB40 + deKin;        
    }  else
      if (vsubstr6 == "HEXB41") {
        EHEXB41 = EHEXB41 + deKin;        
    }  else
      if (vsubstr6 == "HEXB42") {
        EHEXB42 = EHEXB42 + deKin;        
    }  else
      if (vsubstr6 == "HEXB43") {
        EHEXB43 = EHEXB43 + deKin;        
    }  else
      if (vsubstr6 == "HEXB44") {
        EHEXB44 = EHEXB44 + deKin;        
    }  else
      if (vsubstr6 == "HEXB45") {
        EHEXB45 = EHEXB45 + deKin;        
    }  else
      if (vsubstr6 == "HEXB46") {
        EHEXB46 = EHEXB46 + deKin;        
    }  else
      if (vsubstr6 == "HEXB47") {
        EHEXB47 = EHEXB47 + deKin;        
    }  else
      if (vsubstr6 == "HEXB48") {
        EHEXB48 = EHEXB48 + deKin;        
    }  else
      if (vsubstr6 == "HEXB49") {
        EHEXB49 = EHEXB49 + deKin;
    }   else                  
      if (vsubstr6 == "HEXC_0") {
        EHEXC_0 = EHEXC_0 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_1") {
        EHEXC_1 = EHEXC_1 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_2") {
        EHEXC_2 = EHEXC_2 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_3") {
        EHEXC_3 = EHEXC_3 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_4") {
        EHEXC_4 = EHEXC_4 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_5") {
        EHEXC_5 = EHEXC_5 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_6") {
        EHEXC_6 = EHEXC_6 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_7") {
        EHEXC_7 = EHEXC_7 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_8") {
        EHEXC_8 = EHEXC_8 + deKin;        
    }  else
      if (vsubstr6 == "HEXC_9") {
        EHEXC_9 = EHEXC_9 + deKin;        
    }  else
      if (vsubstr6 == "HEXC10") {
        EHEXC10 = EHEXC10 + deKin;        
    }  else
      if (vsubstr6 == "HEXC11") {
        EHEXC11 = EHEXC11 + deKin;        
    }  else
      if (vsubstr6 == "HEXC12") {
        EHEXC12 = EHEXC12 + deKin;        
    }  else
      if (vsubstr6 == "HEXC13") {
        EHEXC13 = EHEXC13 + deKin;        
    }  else
      if (vsubstr6 == "HEXC14") {
        EHEXC14 = EHEXC14 + deKin;        
    }  else
      if (vsubstr6 == "HEXC15") {
        EHEXC15 = EHEXC15 + deKin;        
    }  else
      if (vsubstr6 == "HEXC16") {
        EHEXC16 = EHEXC16 + deKin;        
    }  else
      if (vsubstr6 == "HEXC17") {
        EHEXC17 = EHEXC17 + deKin;        
    }  else
      if (vsubstr6 == "HEXC18") {
        EHEXC18 = EHEXC18 + deKin;        
    }  else
      if (vsubstr6 == "HEXC19") {
        EHEXC19 = EHEXC19 + deKin;         
    }  else
      if (vsubstr6 == "HEXC20") {
        EHEXC20 = EHEXC20 + deKin;        
    }  else
      if (vsubstr6 == "HEXC21") {
        EHEXC21 = EHEXC21 + deKin;        
    }  else
      if (vsubstr6 == "HEXC22") {
        EHEXC22 = EHEXC22 + deKin;        
    }  else
      if (vsubstr6 == "HEXC23") {
        EHEXC23 = EHEXC23 + deKin;        
    }  else
      if (vsubstr6 == "HEXC24") {
        EHEXC24 = EHEXC24 + deKin;        
    }  else
      if (vsubstr6 == "HEXC25") {
        EHEXC25 = EHEXC25 + deKin;        
    }  else
      if (vsubstr6 == "HEXC26") {
        EHEXC26 = EHEXC26 + deKin;        
    }  else
      if (vsubstr6 == "HEXC27") {
        EHEXC27 = EHEXC27 + deKin;        
    }  else
      if (vsubstr6 == "HEXC28") {
        EHEXC28 = EHEXC28 + deKin;        
    }  else
      if (vsubstr6 == "HEXC29") {
        EHEXC29 = EHEXC29 + deKin;         
    }  else
      if (vsubstr6 == "HEXC30") {
        EHEXC30 = EHEXC30 + deKin;        
    }  else
      if (vsubstr6 == "HEXC31") {
        EHEXC31 = EHEXC31 + deKin;        
    }  else
      if (vsubstr6 == "HEXC32") {
        EHEXC32 = EHEXC32 + deKin;        
    }  else
      if (vsubstr6 == "HEXC33") {
        EHEXC33 = EHEXC33 + deKin;        
    }  else
      if (vsubstr6 == "HEXC34") {
        EHEXC34 = EHEXC34 + deKin;        
    }  else
      if (vsubstr6 == "HEXC35") {
        EHEXC35 = EHEXC35 + deKin;        
    }  else
      if (vsubstr6 == "HEXC36") {
        EHEXC36 = EHEXC36 + deKin;        
    }  else
      if (vsubstr6 == "HEXC37") {
        EHEXC37 = EHEXC37 + deKin;        
    }  else
      if (vsubstr6 == "HEXC38") {
        EHEXC38 = EHEXC38 + deKin;        
    }  else
      if (vsubstr6 == "HEXC39") {
        EHEXC39 = EHEXC39 + deKin;         
    }  else
      if (vsubstr6 == "HEXC40") {
        EHEXC40 = EHEXC40 + deKin;        
    }  else
      if (vsubstr6 == "HEXC41") {
        EHEXC41 = EHEXC41 + deKin;        
    }  else
      if (vsubstr6 == "HEXC42") {
        EHEXC42 = EHEXC42 + deKin;        
    }  else
      if (vsubstr6 == "HEXC43") {
        EHEXC43 = EHEXC43 + deKin;        
    }  else
      if (vsubstr6 == "HEXC44") {
        EHEXC44 = EHEXC44 + deKin;        
    }  else
      if (vsubstr6 == "HEXC45") {
        EHEXC45 = EHEXC45 + deKin;        
    }  else
      if (vsubstr6 == "HEXC46") {
        EHEXC46 = EHEXC46 + deKin;        
    }  else
      if (vsubstr6 == "HEXC47") {
        EHEXC47 = EHEXC47 + deKin;        
    }  else
      if (vsubstr6 == "HEXC48") {
        EHEXC48 = EHEXC48 + deKin;        
    }  else
      if (vsubstr6 == "HEXC49") {
        EHEXC49 = EHEXC49 + deKin;                   
    }   else                  
      if (vsubstr6 == "HEXD_0") {
        EHEXD_0 = EHEXD_0 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_1") {
        EHEXD_1 = EHEXD_1 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_2") {
        EHEXD_2 = EHEXD_2 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_3") {
        EHEXD_3 = EHEXD_3 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_4") {
        EHEXD_4 = EHEXD_4 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_5") {
        EHEXD_5 = EHEXD_5 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_6") {
        EHEXD_6 = EHEXD_6 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_7") {
        EHEXD_7 = EHEXD_7 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_8") {
        EHEXD_8 = EHEXD_8 + deKin;        
    }  else
      if (vsubstr6 == "HEXD_9") {
        EHEXD_9 = EHEXD_9 + deKin;        
    }  else
      if (vsubstr6 == "HEXD10") {
        EHEXD10 = EHEXD10 + deKin;        
    }  else
      if (vsubstr6 == "HEXD11") {
        EHEXD11 = EHEXD11 + deKin;        
    }  else
      if (vsubstr6 == "HEXD12") {
        EHEXD12 = EHEXD12 + deKin;        
    }  else
      if (vsubstr6 == "HEXD13") {
        EHEXD13 = EHEXD13 + deKin;        
    }  else
      if (vsubstr6 == "HEXD14") {
        EHEXD14 = EHEXD14 + deKin;        
    }  else
      if (vsubstr6 == "HEXD15") {
        EHEXD15 = EHEXD15 + deKin;        
    }  else
      if (vsubstr6 == "HEXD16") {
        EHEXD16 = EHEXD16 + deKin;        
    }  else
      if (vsubstr6 == "HEXD17") {
        EHEXD17 = EHEXD17 + deKin;        
    }  else
      if (vsubstr6 == "HEXD18") {
        EHEXD18 = EHEXD18 + deKin;        
    }  else
      if (vsubstr6 == "HEXD19") {
        EHEXD19 = EHEXD19 + deKin;         
    }  else
      if (vsubstr6 == "HEXD20") {
        EHEXD20 = EHEXD20 + deKin;        
    }  else
      if (vsubstr6 == "HEXD21") {
        EHEXD21 = EHEXD21 + deKin;        
    }  else
      if (vsubstr6 == "HEXD22") {
        EHEXD22 = EHEXD22 + deKin;        
    }  else
      if (vsubstr6 == "HEXD23") {
        EHEXD23 = EHEXD23 + deKin;        
    }  else
      if (vsubstr6 == "HEXD24") {
        EHEXD24 = EHEXD24 + deKin;        
    }  else
      if (vsubstr6 == "HEXD25") {
        EHEXD25 = EHEXD25 + deKin;        
    }  else
      if (vsubstr6 == "HEXD26") {
        EHEXD26 = EHEXD26 + deKin;        
    }  else
      if (vsubstr6 == "HEXD27") {
        EHEXD27 = EHEXD27 + deKin;        
    }  else
      if (vsubstr6 == "HEXD28") {
        EHEXD28 = EHEXD28 + deKin;        
    }  else
      if (vsubstr6 == "HEXD29") {
        EHEXD29 = EHEXD29 + deKin;         
    }  else
      if (vsubstr6 == "HEXD30") {
        EHEXD30 = EHEXD30 + deKin;        
    }  else
      if (vsubstr6 == "HEXD31") {
        EHEXD31 = EHEXD31 + deKin;        
    }  else
      if (vsubstr6 == "HEXD32") {
        EHEXD32 = EHEXD32 + deKin;        
    }  else
      if (vsubstr6 == "HEXD33") {
        EHEXD33 = EHEXD33 + deKin;        
    }  else
      if (vsubstr6 == "HEXD34") {
        EHEXD34 = EHEXD34 + deKin;        
    }  else
      if (vsubstr6 == "HEXD35") {
        EHEXD35 = EHEXD35 + deKin;        
    }  else
      if (vsubstr6 == "HEXD36") {
        EHEXD36 = EHEXD36 + deKin;        
    }  else
      if (vsubstr6 == "HEXD37") {
        EHEXD37 = EHEXD37 + deKin;        
    }  else
      if (vsubstr6 == "HEXD38") {
        EHEXD38 = EHEXD38 + deKin;        
    }  else
      if (vsubstr6 == "HEXD39") {
        EHEXD39 = EHEXD39 + deKin;                 
    }  else                  
      if (vsubstr6 == "HH1D_0") {
        EHH1D_0 = EHH1D_0 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_1") {
        EHH1D_1 = EHH1D_1 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_2") {
        EHH1D_2 = EHH1D_2 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_3") {
        EHH1D_3 = EHH1D_3 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_4") {
        EHH1D_4 = EHH1D_4 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_5") {
        EHH1D_5 = EHH1D_5 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_6") {
        EHH1D_6 = EHH1D_6 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_7") {
        EHH1D_7 = EHH1D_7 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_8") {
        EHH1D_8 = EHH1D_8 + deKin;        
    }  else                  
      if (vsubstr6 == "HH1D_9") {
        EHH1D_9 = EHH1D_9 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_0") {
        EHH2D_0 = EHH2D_0 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_1") {
        EHH2D_1 = EHH2D_1 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_2") {
        EHH2D_2 = EHH2D_2 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_3") {
        EHH2D_3 = EHH2D_3 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_4") {
        EHH2D_4 = EHH2D_4 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_5") {
        EHH2D_5 = EHH2D_5 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_6") {
        EHH2D_6 = EHH2D_6 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_7") {
        EHH2D_7 = EHH2D_7 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_8") {
        EHH2D_8 = EHH2D_8 + deKin;        
    }  else                  
      if (vsubstr6 == "HH2D_9") {
        EHH2D_9 = EHH2D_9 + deKin;        
    }  else
      if (vsubstr6 == "VT1V_0") {
        EVT1V_0 = EVT1V_0 + deKin;
    }  else
      if (vsubstr6 == "VT1V_1") {
        EVT1V_1 = EVT1V_1 + deKin;
    }  else
      if (vsubstr6 == "VT1V_2") {
        EVT1V_2 = EVT1V_2 + deKin;
    }  else
      if (vsubstr6 == "VT1V_3") {
        EVT1V_3 = EVT1V_3 + deKin;
    }  else
      if (vsubstr6 == "VT1V_4") {
        EVT1V_4 = EVT1V_4 + deKin;
    }  else
      if (vsubstr6 == "VT1V_5") {
        EVT1V_5 = EVT1V_5 + deKin;
    }  else
      if (vsubstr6 == "VT1V_6") {
        EVT1V_6 = EVT1V_6 + deKin;
    }  else
      if (vsubstr6 == "VT1V_7") {
        EVT1V_7 = EVT1V_7 + deKin;
    }  else
      if (vsubstr6 == "VT1V_8") {
        EVT1V_8 = EVT1V_8 + deKin;
    }  else
      if (vsubstr6 == "VT1V_9") {
        EVT1V_9 = EVT1V_9 + deKin;
    }  else
      if (vsubstr6 == "VT2V_0") {
        EVT2V_0 = EVT2V_0 + deKin;
    }  else
      if (vsubstr6 == "VT2V_1") {
        EVT2V_1 = EVT2V_1 + deKin;
    }  else
      if (vsubstr6 == "VT2V_2") {
        EVT2V_2 = EVT2V_2 + deKin;
    }  else
      if (vsubstr6 == "VT2V_3") {
        EVT2V_3 = EVT2V_3 + deKin;
    }  else
      if (vsubstr6 == "VT2V_4") {
        EVT2V_4 = EVT2V_4 + deKin;
    }  else
      if (vsubstr6 == "VT2V_5") {
        EVT2V_5 = EVT2V_5 + deKin;
    }  else
      if (vsubstr6 == "VT2V_6") {
        EVT2V_6 = EVT2V_6 + deKin;
    }  else
      if (vsubstr6 == "VT2V_7") {
        EVT2V_7 = EVT2V_7 + deKin;
    }  else
      if (vsubstr6 == "VT2V_8") {
        EVT2V_8 = EVT2V_8 + deKin;
    }  else
      if (vsubstr6 == "VT2V_9") {
        EVT2V_9 = EVT2V_9 + deKin;
    }
   }

   
// particles
// WHERE  - flag,where (pi+,mu+,e+,e-,gamma,other) particle is:
//          before GAS1 - by default WHERE = 0 
//          in GAS1 - we set variable WHERE to 1
//          after GAS1 - set to 2
//          in GAS2    - set to 3
//          after GAS2 - set to 4
//          in PV0i    - set to 5
//          after PV0i - set to 6
//          in CsI     - set to 7


// PRTCL - particle name = 1 - pi+
//                       = 2 - mu+
//                       = 3 - e+
//                       = 4 - e-
//                       = 5 - gamma
//                       = 6 - proton
//                       = 7 - triton
//                       = 8 - alpha
//                       = 9 - pi0
//                       = 10 - Cs133[0.0]
//                       = 11 - I127[0.0] 
//                       = 12 - other

// vol          < 0, vertex position of particle ( = -1 - DEGR, = -2 - TARGET, -3 - other )  
//              = 3,  mwpc1  position of particle                                        
//              = 4,  mwpc2  position of particle
//              = 100+i,  pvi   position of particle
//              = 200+volume.substr(4,2),  csi    position of particle
  
  
    if (track->GetVolume()) {       
//       if (((track->GetDefinition()->GetParticleName() == "pi+") ||
//       (track->GetDefinition()->GetParticleName() == "mu+") ||
//       (track->GetDefinition()->GetParticleName() == "e+") ||
//       (track->GetDefinition()->GetParticleName() == "e-") ||
//       (track->GetDefinition()->GetParticleName() == "gamma")))  {
        if ((ID != IDCURRENT) && (vsubstr4 != "MAMA") && (vsubstr4 != "DEGR") && (vsubstr1 != "T") && (vsubstr3 != "ENC"))
          { 
          IDCURRENT  = ID;
          PIDCURRENT = (track->GetParentID());
                 if (particle == "pi+") {
                     PRTCL = 1;  
            } else if (particle == "mu+") { 
           PRTCL = 2;
            } else if (particle == "e+")  { 
           PRTCL = 3;
            } else if (particle == "e-")  {
           PRTCL = 4;
            } else if (particle == "gamma")  {
           PRTCL = 5;
            } else if (particle == "proton")  {
           PRTCL = 6;
            } else if (particle == "triton")  {
           PRTCL = 7;
            } else if (particle == "alpha")  {
           PRTCL = 8;
            } else if (particle == "pi0")  {
           PRTCL = 9;
            } else if (particle == "Cs133[0.0]")  {
           PRTCL = 10;         
            } else if (particle == "I127[0.0]")  {
           PRTCL = 11;                         
            } else     { 
           PRTCL = 12;
       G4cout << std::setw(10) << particle << " particle "<< G4endl;
           }    
          G4ThreeVector vertexpos = track->GetVertexPosition();
          vertexx = vertexpos.x();
              vertexy = vertexpos.y();
              vertexz = vertexpos.z();
              G4ThreeVector vertexdir = track->GetVertexMomentumDirection();
              vertexdirX = vertexdir.x();
              vertexdirY = vertexdir.y();
              vertexdirZ = vertexdir.z();
          vertexeKin = track->GetVertexKineticEnergy();
          G4double vertextime = (track->GetGlobalTime())-(track->GetLocalTime())  ;
      vvertex = track->GetLogicalVolumeAtVertex()->GetName();
      if (vvertex == "DEGR") {
          volume = -1;
              } else         
       if (vvertex.substr(0,1) == "T") {         
             volume = -2;
              } else              {
         volume = -3;
          }
         WHERE = 0;
                   
         ntuple101->fill( ntuple101->findColumn( "event"   ), (G4double) event );
         ntuple101->fill( ntuple101->findColumn( "id"      ), (G4double) IDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "pid"     ), (G4double) PIDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "particle"), (G4double) PRTCL );
         ntuple101->fill( ntuple101->findColumn( "vol"     ), (G4double) volume );
         ntuple101->fill( ntuple101->findColumn( "x"       ), (G4double) vertexx );
         ntuple101->fill( ntuple101->findColumn( "y"       ), (G4double) vertexy );
         ntuple101->fill( ntuple101->findColumn( "z"       ), (G4double) vertexz );
         ntuple101->fill( ntuple101->findColumn( "dirx"       ), (G4double) vertexdirX );
         ntuple101->fill( ntuple101->findColumn( "diry"       ), (G4double) vertexdirY );
         ntuple101->fill( ntuple101->findColumn( "dirz"       ), (G4double) vertexdirZ );                
         ntuple101->fill( ntuple101->findColumn( "enrg"    ), (G4double) vertexeKin );
         ntuple101->fill( ntuple101->findColumn( "denrg"   ), (G4double) ZERO );
         ntuple101->fill( ntuple101->findColumn( "time"    ), (G4double) vertextime );
         ntuple101->addRow();
               }
             }

    if (track->GetVolume()) {
       if ((vsubstr4 == "GAS1") &&
         (WHERE != 1) && (ID == IDCURRENT)) {
         //G4ThreeVector posl = aStep->GetPreStepPoint()->GetPosition();
         GAS1lx    = xpre;
         GAS1ly    = ypre;
         GAS1lz    = zpre;
         GAS1dirx  = dirX;
         GAS1diry  = dirY;
         GAS1dirz  = dirZ;
             GAS1enrg  = 0.0;
             GAS1denrg = 0.0;
             GAS1ltime = timepre;
         GAS1count = 0.0;
         WHERE = 1;
         }             
       }
     
    if (track->GetVolume()) {         
            if ((vsubstr4 == "GAS1") &&
         (WHERE == 1) && (ID == IDCURRENT)) { 
             GAS1enrg  = GAS1enrg+eKin;
             GAS1denrg = GAS1denrg+deKin;
         GAS1count = GAS1count+1.0;      
          }    
        }
     
    if (track->GetVolume()) {           
            if ((vsubstr4 == "GAS1") && ((nextvol != "GAS1") || (eKin == 0.0)) &&           
         (WHERE == 1) && (ID == IDCURRENT)) {
         //G4ThreeVector posr = aStep->GetPostStepPoint()->GetPosition();
         GAS1rx    = xpost;
         GAS1ry    = ypost;
         GAS1rz    = zpost;
         GAS1x = GAS1lx+(GAS1rx-GAS1lx)/2.0;
         GAS1y = GAS1ly+(GAS1ry-GAS1ly)/2.0;
         GAS1z = GAS1lz+(GAS1rz-GAS1lz)/2.0;
             GAS1enrg  = GAS1enrg / GAS1count;
             GAS1rtime = timepost;
         GAS1time = (GAS1ltime+GAS1rtime)/2.0;
         WHERE = 0;
         
         ntuple101->fill( ntuple101->findColumn( "event"   ), (G4double) event );
         ntuple101->fill( ntuple101->findColumn( "id"      ), (G4double) IDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "pid"     ), (G4double) PIDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "particle"), (G4double) PRTCL );
         ntuple101->fill( ntuple101->findColumn( "vol"     ), (G4double) THREE );
         ntuple101->fill( ntuple101->findColumn( "x"       ), (G4double) GAS1x );
         ntuple101->fill( ntuple101->findColumn( "y"       ), (G4double) GAS1y );
         ntuple101->fill( ntuple101->findColumn( "z"       ), (G4double) GAS1z );     
         ntuple101->fill( ntuple101->findColumn( "dirx"    ), (G4double) GAS1dirx );
         ntuple101->fill( ntuple101->findColumn( "diry"    ), (G4double) GAS1diry );
         ntuple101->fill( ntuple101->findColumn( "dirz"    ), (G4double) GAS1dirz );
         ntuple101->fill( ntuple101->findColumn( "enrg"    ), (G4double) GAS1enrg );
         ntuple101->fill( ntuple101->findColumn( "denrg"   ), (G4double) GAS1denrg );
         ntuple101->fill( ntuple101->findColumn( "time"    ), (G4double) GAS1time );
         ntuple101->addRow();                
      } 
     }
     
    if (track->GetVolume()) {     
            if ((vsubstr4 == "GAS2") &&
         (WHERE != 3) && (ID == IDCURRENT)) {          
         //G4ThreeVector posll = aStep->GetPreStepPoint()->GetPosition();
         GAS2lx    = xpre;
         GAS2ly    = ypre;
         GAS2lz    = zpre;
         GAS2dirx  = dirX;
         GAS2diry  = dirY;
         GAS2dirz  = dirZ;
             GAS2enrg  = 0.0;
             GAS2denrg = 0.0;
             GAS2ltime = timepre;
         GAS2count = 0.0;
         WHERE = 3;
      }             
         }           

    if (track->GetVolume()) {         
            if ((vsubstr4 == "GAS2") &&
         (WHERE == 3) && (ID == IDCURRENT)) { 
             GAS2enrg  = GAS2enrg+eKin;
             GAS2denrg = GAS2denrg+deKin;
         GAS2count = GAS2count+1.0;      
     }    
        }
    
    if (track->GetVolume()) {     
            if ((vsubstr4 == "GAS2") && ((nextvol != "GAS2") || (eKin == 0.0)) && 
         (WHERE == 3) && (ID == IDCURRENT)) {        
         //G4ThreeVector posrr = aStep->GetPostStepPoint()->GetPosition();
         GAS2rx    = xpost;
         GAS2ry    = ypost;
         GAS2rz    = zpost;
         GAS2x = GAS2lx+(GAS2rx-GAS2lx)/2.0;
         GAS2y = GAS2ly+(GAS2ry-GAS2ly)/2.0;
         GAS2z = GAS2lz+(GAS2rz-GAS2lz)/2.0;
             GAS2enrg  = GAS2enrg / GAS2count;
             GAS2rtime = timepost;
         GAS2time = (GAS2ltime+GAS2rtime)/2.0;
         WHERE = 2;
         
         ntuple101->fill( ntuple101->findColumn( "event"   ), (G4double) event );
         ntuple101->fill( ntuple101->findColumn( "id"      ), (G4double) IDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "pid"     ), (G4double) PIDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "particle"), (G4double) PRTCL );
         ntuple101->fill( ntuple101->findColumn( "vol"     ), (G4double) FOUR );
         ntuple101->fill( ntuple101->findColumn( "x"       ), (G4double) GAS2x );
         ntuple101->fill( ntuple101->findColumn( "y"       ), (G4double) GAS2y );
         ntuple101->fill( ntuple101->findColumn( "z"       ), (G4double) GAS2z );       
         ntuple101->fill( ntuple101->findColumn( "dirx"    ), (G4double) GAS2dirx );
         ntuple101->fill( ntuple101->findColumn( "diry"    ), (G4double) GAS2diry );
         ntuple101->fill( ntuple101->findColumn( "dirz"    ), (G4double) GAS2dirz );
         ntuple101->fill( ntuple101->findColumn( "enrg"    ), (G4double) GAS2enrg );
         ntuple101->fill( ntuple101->findColumn( "denrg"   ), (G4double) GAS2denrg );
         ntuple101->fill( ntuple101->findColumn( "time"    ), (G4double) GAS2time );
         ntuple101->addRow();                
      } 
     }

    if (track->GetVolume()) {     
       if (((vsubstr3 == "PV0") ||
            (vsubstr3 == "PV1") ||
            (vsubstr3 == "PV2")) &&    
        (WHERE != 5) && (ID == IDCURRENT)) {
     std::istringstream is(vsubstr4.substr(2,2));
     is >> volume;
     volume = volume + 100;         
         //G4ThreeVector pospl = aStep->GetPreStepPoint()->GetPosition();
         PVETlx    = xpre;
         PVETly    = ypre;
         PVETlz    = zpre;
         PVETdirx  = dirX;
         PVETdiry  = dirY;
         PVETdirz  = dirZ;
             PVETenrg  = 0.0;
             PVETdenrg = 0.0;
             PVETltime = timepre;
         PVETcount = 0.0;
         WHERE = 5;
      }             
         }           

    if (track->GetVolume()) {         
       if (((vsubstr3 == "PV0") ||
            (vsubstr3 == "PV1") ||
            (vsubstr3 == "PV2")) &&   
         (WHERE == 5) && (ID == IDCURRENT)) { 
             PVETenrg  = PVETenrg+eKin;
             PVETdenrg = PVETdenrg+deKin;
         PVETcount = PVETcount+1.0;      
     }    
        }
    
    if (track->GetVolume()) {
       if (((vsubstr3 == "PV0") ||
            (vsubstr3 == "PV1") ||
            (vsubstr3 == "PV2")) &&
            ((nextvol == "PVET") || (nextvol.substr(0,2) != "PV") || (eKin == 0.0)) &&
         (WHERE == 5) && (ID == IDCURRENT)) {        
         //G4ThreeVector pospr = aStep->GetPostStepPoint()->GetPosition();
         PVETrx    = xpost;
         PVETry    = ypost;
         PVETrz    = zpost;
         PVETx = PVETlx+(PVETrx-PVETlx)/2.0;
         PVETy = PVETly+(PVETry-PVETly)/2.0;
         PVETz = PVETlz+(PVETrz-PVETlz)/2.0; 
             PVETenrg  = PVETenrg / PVETcount;
             PVETrtime = timepost;
         PVETtime = (PVETltime+PVETrtime)/2.0;
         WHERE = 4;
         
         ntuple101->fill( ntuple101->findColumn( "event"   ), (G4double) event );
         ntuple101->fill( ntuple101->findColumn( "id"      ), (G4double) IDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "pid"     ), (G4double) PIDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "particle"), (G4double) PRTCL );
         ntuple101->fill( ntuple101->findColumn( "vol"     ), (G4double) volume );
         ntuple101->fill( ntuple101->findColumn( "x"       ), (G4double) PVETx );
         ntuple101->fill( ntuple101->findColumn( "y"       ), (G4double) PVETy );
         ntuple101->fill( ntuple101->findColumn( "z"       ), (G4double) PVETz );      
         ntuple101->fill( ntuple101->findColumn( "dirx"    ), (G4double) PVETdirx );
         ntuple101->fill( ntuple101->findColumn( "diry"    ), (G4double) PVETdiry );
         ntuple101->fill( ntuple101->findColumn( "dirz"    ), (G4double) PVETdirz );
         ntuple101->fill( ntuple101->findColumn( "enrg"    ), (G4double) PVETenrg );
         ntuple101->fill( ntuple101->findColumn( "denrg"   ), (G4double) PVETdenrg );
         ntuple101->fill( ntuple101->findColumn( "time"    ), (G4double) PVETtime );
         ntuple101->addRow();                
      } 
     } 
     
    if (track->GetVolume()) {     
       if (((vsubstr1 == "H") ||
            (vsubstr1 == "V") ||
            (vsubstr2 == "PE")) &&    
        (WHERE != 7) && (ID == IDCURRENT)) {
     vcsi = track->GetVolume()->GetName();
     if (vcsi.substr(4,1) == "_") {
     std::istringstream is(vcsi.substr(5,1));
     is >> volume;
      } else {
       std::istringstream is(vcsi.substr(4,2));
       is >> volume;
       }     
         if (vsubstr4 == "PENT") {
        volume = volume + 200.0; 
        }
       else if (vsubstr4 == "HEXA") {
        volume = volume + 210.0;
        }
       else if (vsubstr4 == "HEXB") {
        volume = volume + 260.0;
        }
       else if (vsubstr4 == "HEXC") {
        volume = volume + 310.0;
        }
       else if (vsubstr4 == "HEXD") {
        volume = volume + 360.0;
        }
       else if (vsubstr4 == "HH1D") {
        volume = volume + 400.0;
        }
       else if (vsubstr4 == "HH2D") {
        volume = volume + 410.0;
        }
       else if (vsubstr4 == "VT1V") {
        volume = volume + 420.0;
        }
       else if (vsubstr4 == "VT2V") {
        volume = volume + 430.0;
        }
       //illegal csi
       else { 
        volume = 0.0; 
        }                                                     
         //G4ThreeVector poscsi = aStep->GetPreStepPoint()->GetPosition();
         csix    = x;
         csiy    = y;
         csiz    = z;
         csidirx  = dirX;
         csidiry  = dirY;
         csidirz  = dirZ;
             csienrg  = eKin;
             csidenrg = 0.0;
             csitime = timepre;
         WHERE = 7;  
      }             
         }   
     
    if (track->GetVolume()) {     
       if (((vsubstr1 == "H") ||
            (vsubstr1 == "V") ||
            (vsubstr2 == "PE")) &&    
        (WHERE == 7) && (ID == IDCURRENT) && (vcsi == track->GetVolume()->GetName())) {
             csidenrg = csidenrg+deKin;          
      }             
         }                       
     
    if (track->GetVolume()) {
       if (((vsubstr1 == "H") ||
            (vsubstr1 == "V") ||
            (vsubstr2 == "PE")) &&                    
        (WHERE == 7) && (ID == IDCURRENT) && ((vcsi != nextvol) || (eKin == 0.0))) {
             WHERE = 6;
         ntuple101->fill( ntuple101->findColumn( "event"   ), (G4double) event );
         ntuple101->fill( ntuple101->findColumn( "id"      ), (G4double) IDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "pid"     ), (G4double) PIDCURRENT );
         ntuple101->fill( ntuple101->findColumn( "particle"), (G4double) PRTCL );
         ntuple101->fill( ntuple101->findColumn( "vol"     ), (G4double) volume );
         ntuple101->fill( ntuple101->findColumn( "x"       ), (G4double) csix );
         ntuple101->fill( ntuple101->findColumn( "y"       ), (G4double) csiy );
         ntuple101->fill( ntuple101->findColumn( "z"       ), (G4double) csiz );         
         ntuple101->fill( ntuple101->findColumn( "dirx"    ), (G4double) csidirx );
         ntuple101->fill( ntuple101->findColumn( "diry"    ), (G4double) csidiry );
         ntuple101->fill( ntuple101->findColumn( "dirz"    ), (G4double) csidirz );
         ntuple101->fill( ntuple101->findColumn( "enrg"    ), (G4double) csienrg );
         ntuple101->fill( ntuple101->findColumn( "denrg"   ), (G4double) csidenrg );
         ntuple101->fill( ntuple101->findColumn( "time"    ), (G4double) csitime );
         ntuple101->addRow();                    
      }             
         }
     
#endif
}
// Write to file
//if (entering) {
// std::ofstream asciiFile(asciiFileName, std::ios::app);
//  if(asciiFile.is_open()) {
//    asciiFile << std::setiosflags(std::ios::fixed)
//      << std::setprecision(3)
//      << std::setiosflags(std::ios::right)
//      << std::setw(10);
//      asciiFile << deKin;
//      asciiFile << std::setiosflags(std::ios::fixed)
//      << std::setprecision(3)
//      << std::setiosflags(std::ios::right)
//      << std::setw(10);
//      asciiFile << x;
//      asciiFile << std::setiosflags(std::ios::fixed)
//      << std::setprecision(3)
//      << std::setiosflags(std::ios::right)
//      << std::setw(10);
//      asciiFile << y;
//      asciiFile << std::setiosflags(std::ios::fixed)
//      << std::setprecision(3)
//      << std::setiosflags(std::ios::right)
//      << std::setw(10);
//      asciiFile << z
//      << G4endl;
//      asciiFile.close();
//    }
//  }


// #ifdef G4ANALYSIS_USE_PLOTTER
// void XrayTelAnalysis::plotAll()
// {
//   if (!plotter) {
//     AIDA::IPlotterFactory* plotterFactory = 
//       analysisFactory->createPlotterFactory();
//     if(plotterFactory) {
//       G4cout << "Creating the Plotter" << G4endl;
//       plotter = plotterFactory->create();
//       if(plotter) {
//  // Map the plotter on screen :
//  G4cout << "Showing the Plotter on screen" << G4endl;
//  plotter->show();
//       } else {
//  G4cout << "XrayTelAnalysis::plotAll: WARNING: Plotter not created" << G4endl;
//       }
//       delete plotterFactory;
//     } else {
//       G4cout << "XrayTelAnalysis::plotAll: WARNING: Plotter Factory not created" << G4endl;
//     }
//   }

//   if (plotter) {
//     plotter->createRegions(2,1,0);
//     AIDA::IHistogram1D* hp = dynamic_cast<AIDA::IHistogram1D *> ( tree->find("3") );
//     AIDA::IHistogram1D& h  = *hp;  
//     (plotter->currentRegion()).plot(h);
//     plotter->refresh();
//     plotter->setCurrentRegionNumber(1);
//     AIDA::IHistogram1D* hp2 = dynamic_cast<AIDA::IHistogram1D *> ( tree->find("1") );
//     AIDA::IHistogram1D& h2  = *hp2;  
//     (plotter->currentRegion()).plot(h2);
//     plotter->refresh();
//   }
// }
// #endif


 void PSIAnalysis::analysePrimaryGenerator(G4double energy,G4double xx,G4double yy,G4double zz)
 {

 // if(1 < verbose) {
 //   G4cout << "exrdmAnalysisManager::AddEnergy: e(keV)= " << edep/keV
//     << " weight = " << weight << " time (s) = " <<  time/second
//           << G4endl;
//  }



      ntuple100->fill( ntuple100->findColumn( "ein" ), (G4double) energy );


      ntuple100->fill( ntuple100->findColumn( "xin"        ), (G4double) xx );
      ntuple100->fill( ntuple100->findColumn( "yin"        ), (G4double) yy );
      ntuple100->fill( ntuple100->findColumn( "zin"        ), (G4double) zz );
      ntuple100->fill( ntuple100->findColumn( "xdc"        ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "ydc"        ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "zdc"        ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "timedcpre"  ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "timedcpost" ), (G4double) ZERO );      
      ntuple100->fill( ntuple100->findColumn( "xmdc"       ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "ymdc"       ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "zmdc"       ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "timemdcpre" ), (G4double) ZERO );
      ntuple100->fill( ntuple100->findColumn( "timemdcpost"), (G4double) ZERO );
        
      decayevent = 3;
      

      EDEGR = 0.0;
      ETARGET = 0.0;
      EMWPC1 = 0.0;
      EMWPC2 = 0.0;
      EPV01 = 0.0;
      EPV02 = 0.0;
      EPV03 = 0.0;
      EPV04 = 0.0;
      EPV05 = 0.0;
      EPV06 = 0.0;
      EPV07 = 0.0;
      EPV08 = 0.0;
      EPV09 = 0.0;
      EPV10 = 0.0;
      EPV11 = 0.0;
      EPV12 = 0.0;
      EPV13 = 0.0;
      EPV14 = 0.0;
      EPV15 = 0.0;
      EPV16 = 0.0;
      EPV17 = 0.0;
      EPV18 = 0.0;
      EPV19 = 0.0;
      EPV20 = 0.0;      

      EPENT_0 = 0.0;
      EPENT_1 = 0.0;
      EPENT_2 = 0.0;
      EPENT_3 = 0.0;
      EPENT_4 = 0.0;
      EPENT_5 = 0.0;
      EPENT_6 = 0.0;
      EPENT_7 = 0.0;
      EPENT_8 = 0.0;
      EPENT_9 = 0.0;
      EHEXA_0 = 0.0;
      EHEXA_1 = 0.0;
      EHEXA_2 = 0.0;
      EHEXA_3 = 0.0;
      EHEXA_4 = 0.0;
      EHEXA_5 = 0.0;
      EHEXA_6 = 0.0;
      EHEXA_7 = 0.0;
      EHEXA_8 = 0.0;
      EHEXA_9 = 0.0;
      EHEXA10 = 0.0;
      EHEXA11 = 0.0;
      EHEXA12 = 0.0;
      EHEXA13 = 0.0;
      EHEXA14 = 0.0;
      EHEXA15 = 0.0;
      EHEXA16 = 0.0;
      EHEXA17 = 0.0;
      EHEXA18 = 0.0;
      EHEXA19 = 0.0;
      EHEXA20 = 0.0;
      EHEXA21 = 0.0;
      EHEXA22 = 0.0;
      EHEXA23 = 0.0;
      EHEXA24 = 0.0;
      EHEXA25 = 0.0;
      EHEXA26 = 0.0;
      EHEXA27 = 0.0;
      EHEXA28 = 0.0;
      EHEXA29 = 0.0;
      EHEXA30 = 0.0;
      EHEXA31 = 0.0;
      EHEXA32 = 0.0;
      EHEXA33 = 0.0;
      EHEXA34 = 0.0;
      EHEXA35 = 0.0;
      EHEXA36 = 0.0;
      EHEXA37 = 0.0;
      EHEXA38 = 0.0;
      EHEXA39 = 0.0;
      EHEXA40 = 0.0;
      EHEXA41 = 0.0;
      EHEXA42 = 0.0;
      EHEXA43 = 0.0;
      EHEXA44 = 0.0;
      EHEXA45 = 0.0;
      EHEXA46 = 0.0;
      EHEXA47 = 0.0;
      EHEXA48 = 0.0;
      EHEXA49 = 0.0;
      EHEXB_0 = 0.0;
      EHEXB_1 = 0.0;
      EHEXB_2 = 0.0;
      EHEXB_3 = 0.0;
      EHEXB_4 = 0.0;
      EHEXB_5 = 0.0;
      EHEXB_6 = 0.0;
      EHEXB_7 = 0.0;
      EHEXB_8 = 0.0;
      EHEXB_9 = 0.0;
      EHEXB10 = 0.0;
      EHEXB11 = 0.0;
      EHEXB12 = 0.0;
      EHEXB13 = 0.0;
      EHEXB14 = 0.0;
      EHEXB15 = 0.0;
      EHEXB16 = 0.0;
      EHEXB17 = 0.0;
      EHEXB18 = 0.0;
      EHEXB19 = 0.0;
      EHEXB20 = 0.0;
      EHEXB21 = 0.0;
      EHEXB22 = 0.0;
      EHEXB23 = 0.0;
      EHEXB24 = 0.0;
      EHEXB25 = 0.0;
      EHEXB26 = 0.0;
      EHEXB27 = 0.0;
      EHEXB28 = 0.0;
      EHEXB29 = 0.0;
      EHEXB30 = 0.0;
      EHEXB31 = 0.0;
      EHEXB32 = 0.0;
      EHEXB33 = 0.0;
      EHEXB34 = 0.0;
      EHEXB35 = 0.0;
      EHEXB36 = 0.0;
      EHEXB37 = 0.0;
      EHEXB38 = 0.0;
      EHEXB39 = 0.0;
      EHEXB40 = 0.0;
      EHEXB41 = 0.0;
      EHEXB42 = 0.0;
      EHEXB43 = 0.0;
      EHEXB44 = 0.0;
      EHEXB45 = 0.0;
      EHEXB46 = 0.0;
      EHEXB47 = 0.0;
      EHEXB48 = 0.0;
      EHEXB49 = 0.0;
      EHEXC_0 = 0.0;
      EHEXC_1 = 0.0;
      EHEXC_2 = 0.0;
      EHEXC_3 = 0.0;
      EHEXC_4 = 0.0;
      EHEXC_5 = 0.0;
      EHEXC_6 = 0.0;
      EHEXC_7 = 0.0;
      EHEXC_8 = 0.0;
      EHEXC_9 = 0.0;
      EHEXC10 = 0.0;
      EHEXC11 = 0.0;
      EHEXC12 = 0.0;
      EHEXC13 = 0.0;
      EHEXC14 = 0.0;
      EHEXC15 = 0.0;
      EHEXC16 = 0.0;
      EHEXC17 = 0.0;
      EHEXC18 = 0.0;
      EHEXC19 = 0.0;
      EHEXC20 = 0.0;
      EHEXC21 = 0.0;
      EHEXC22 = 0.0;
      EHEXC23 = 0.0;
      EHEXC24 = 0.0;
      EHEXC25 = 0.0;
      EHEXC26 = 0.0;
      EHEXC27 = 0.0;
      EHEXC28 = 0.0;
      EHEXC29 = 0.0;
      EHEXC30 = 0.0;
      EHEXC31 = 0.0;
      EHEXC32 = 0.0;
      EHEXC33 = 0.0;
      EHEXC34 = 0.0;
      EHEXC35 = 0.0;
      EHEXC36 = 0.0;
      EHEXC37 = 0.0;
      EHEXC38 = 0.0;
      EHEXC39 = 0.0;
      EHEXC40 = 0.0;
      EHEXC41 = 0.0;
      EHEXC42 = 0.0;
      EHEXC43 = 0.0;
      EHEXC44 = 0.0;
      EHEXC45 = 0.0;
      EHEXC46 = 0.0;
      EHEXC47 = 0.0;
      EHEXC48 = 0.0;
      EHEXC49 = 0.0;
      EHEXD_0 = 0.0;
      EHEXD_1 = 0.0;
      EHEXD_2 = 0.0;
      EHEXD_3 = 0.0;
      EHEXD_4 = 0.0;
      EHEXD_5 = 0.0;
      EHEXD_6 = 0.0;
      EHEXD_7 = 0.0;
      EHEXD_8 = 0.0;
      EHEXD_9 = 0.0;
      EHEXD10 = 0.0;
      EHEXD11 = 0.0;
      EHEXD12 = 0.0;
      EHEXD13 = 0.0;
      EHEXD14 = 0.0;
      EHEXD15 = 0.0;
      EHEXD16 = 0.0;
      EHEXD17 = 0.0;
      EHEXD18 = 0.0;
      EHEXD19 = 0.0;
      EHEXD20 = 0.0;
      EHEXD21 = 0.0;
      EHEXD22 = 0.0;
      EHEXD23 = 0.0;
      EHEXD24 = 0.0;
      EHEXD25 = 0.0;
      EHEXD26 = 0.0;
      EHEXD27 = 0.0;
      EHEXD28 = 0.0;
      EHEXD29 = 0.0;
      EHEXD30 = 0.0;
      EHEXD31 = 0.0;
      EHEXD32 = 0.0;
      EHEXD33 = 0.0;
      EHEXD34 = 0.0;
      EHEXD35 = 0.0;
      EHEXD36 = 0.0;
      EHEXD37 = 0.0;
      EHEXD38 = 0.0;
      EHEXD39 = 0.0;
      EHH1D_0 = 0.0;
      EHH1D_1 = 0.0;
      EHH1D_2 = 0.0;
      EHH1D_3 = 0.0;
      EHH1D_4 = 0.0;
      EHH1D_5 = 0.0;
      EHH1D_6 = 0.0;
      EHH1D_7 = 0.0;
      EHH1D_8 = 0.0;
      EHH1D_9 = 0.0;
      EHH2D_0 = 0.0;
      EHH2D_1 = 0.0;
      EHH2D_2 = 0.0;
      EHH2D_3 = 0.0;
      EHH2D_4 = 0.0;
      EHH2D_5 = 0.0;
      EHH2D_6 = 0.0;
      EHH2D_7 = 0.0;
      EHH2D_8 = 0.0;
      EHH2D_9 = 0.0;
      EVT1V_0 = 0.0;
      EVT1V_1 = 0.0;
      EVT1V_2 = 0.0;
      EVT1V_3 = 0.0;
      EVT1V_4 = 0.0;
      EVT1V_5 = 0.0;
      EVT1V_6 = 0.0;
      EVT1V_7 = 0.0;
      EVT1V_8 = 0.0;
      EVT1V_9 = 0.0;
      EVT2V_0 = 0.0;
      EVT2V_1 = 0.0;
      EVT2V_2 = 0.0;
      EVT2V_3 = 0.0;
      EVT2V_4 = 0.0;
      EVT2V_5 = 0.0;
      EVT2V_6 = 0.0;
      EVT2V_7 = 0.0;
      EVT2V_8 = 0.0;
      EVT2V_9 = 0.0;
  // Filling of energy spectrum histogram of the primary generator

//  histo->fillTuple(2,"Weight",weight);
//  histo->fillTuple(2,"Time",time/second);
//  histo->addRow(2);
  //
//  exrdmEnergyDeposition A(edep,time,weight);
//  Edepo.push_back(A);
 }

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....

 void PSIAnalysis::analyseBeginofEvent(G4int evtNbegin)
 {
 
     event = evtNbegin;
     
     WHERE = 0;
     PRTCL = 0;
     IDCURRENT = 0;
   }  
 
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.... 
 
 
 
 
 void PSIAnalysis::analyseEndofEvent(G4int evtNb) 
 {

//  decayevent = 0 - o step
//  decayevent = 1 - PI+ Decay in DEGR
//  decayevent = 2 - PI+ Decay in TARGET
//  decayevent = 3 - not Decay in DEGR or TARGET


      ntuple100->fill( ntuple100->findColumn( "event"  ), (G4double)   evtNb );      
      ntuple100->fill( ntuple100->findColumn( "btstop" ), (G4double)   decayevent );
      ntuple100->fill( ntuple100->findColumn( "degr"   ), (G4double)   EDEGR );
      ntuple100->fill( ntuple100->findColumn( "target" ), (G4double)   ETARGET );
      ntuple100->fill( ntuple100->findColumn( "mwpc1"  ), (G4double)   EMWPC1 );
      ntuple100->fill( ntuple100->findColumn( "mwpc2"  ), (G4double)   EMWPC2 );
      ntuple100->fill( ntuple100->findColumn( "pv01"   ), (G4double)   EPV01 );
      ntuple100->fill( ntuple100->findColumn( "pv02"   ), (G4double)   EPV02 );
      ntuple100->fill( ntuple100->findColumn( "pv03"   ), (G4double)   EPV03 );
      ntuple100->fill( ntuple100->findColumn( "pv04"   ), (G4double)   EPV04 );
      ntuple100->fill( ntuple100->findColumn( "pv05"   ), (G4double)   EPV05 );
      ntuple100->fill( ntuple100->findColumn( "pv06"   ), (G4double)   EPV06 );
      ntuple100->fill( ntuple100->findColumn( "pv07"   ), (G4double)   EPV07 );
      ntuple100->fill( ntuple100->findColumn( "pv08"   ), (G4double)   EPV08 );
      ntuple100->fill( ntuple100->findColumn( "pv09"   ), (G4double)   EPV09 );
      ntuple100->fill( ntuple100->findColumn( "pv10"   ), (G4double)   EPV10 );
      ntuple100->fill( ntuple100->findColumn( "pv11"   ), (G4double)   EPV11 );
      ntuple100->fill( ntuple100->findColumn( "pv12"   ), (G4double)   EPV12 );
      ntuple100->fill( ntuple100->findColumn( "pv13"   ), (G4double)   EPV13 );
      ntuple100->fill( ntuple100->findColumn( "pv14"   ), (G4double)   EPV14 );
      ntuple100->fill( ntuple100->findColumn( "pv15"   ), (G4double)   EPV15 );
      ntuple100->fill( ntuple100->findColumn( "pv16"   ), (G4double)   EPV16 );
      ntuple100->fill( ntuple100->findColumn( "pv17"   ), (G4double)   EPV17 );
      ntuple100->fill( ntuple100->findColumn( "pv18"   ), (G4double)   EPV18 );
      ntuple100->fill( ntuple100->findColumn( "pv19"   ), (G4double)   EPV19 );
      ntuple100->fill( ntuple100->findColumn( "pv20"   ), (G4double)   EPV20 );      
      ntuple100->fill( ntuple100->findColumn( "pent_0" ), (G4double)   EPENT_0 );
      ntuple100->fill( ntuple100->findColumn( "pent_1" ), (G4double)   EPENT_1 );
      ntuple100->fill( ntuple100->findColumn( "pent_2" ), (G4double)   EPENT_2 );
      ntuple100->fill( ntuple100->findColumn( "pent_3" ), (G4double)   EPENT_3 );
      ntuple100->fill( ntuple100->findColumn( "pent_4" ), (G4double)   EPENT_4 );
      ntuple100->fill( ntuple100->findColumn( "pent_5" ), (G4double)   EPENT_5 );
      ntuple100->fill( ntuple100->findColumn( "pent_6" ), (G4double)   EPENT_6 );
      ntuple100->fill( ntuple100->findColumn( "pent_7" ), (G4double)   EPENT_7 );
      ntuple100->fill( ntuple100->findColumn( "pent_8" ), (G4double)   EPENT_8 );
      ntuple100->fill( ntuple100->findColumn( "pent_9" ), (G4double)   EPENT_9 );
      ntuple100->fill( ntuple100->findColumn( "hexa_0" ), (G4double)   EHEXA_0 );
      ntuple100->fill( ntuple100->findColumn( "hexa_1" ), (G4double)   EHEXA_1 );
      ntuple100->fill( ntuple100->findColumn( "hexa_2" ), (G4double)   EHEXA_2 );
      ntuple100->fill( ntuple100->findColumn( "hexa_3" ), (G4double)   EHEXA_3 );
      ntuple100->fill( ntuple100->findColumn( "hexa_4" ), (G4double)   EHEXA_4 );
      ntuple100->fill( ntuple100->findColumn( "hexa_5" ), (G4double)   EHEXA_5 );
      ntuple100->fill( ntuple100->findColumn( "hexa_6" ), (G4double)   EHEXA_6 );
      ntuple100->fill( ntuple100->findColumn( "hexa_7" ), (G4double)   EHEXA_7 );
      ntuple100->fill( ntuple100->findColumn( "hexa_8" ), (G4double)   EHEXA_8 );
      ntuple100->fill( ntuple100->findColumn( "hexa_9" ), (G4double)   EHEXA_9 );
      ntuple100->fill( ntuple100->findColumn( "hexa10" ), (G4double)   EHEXA10 );
      ntuple100->fill( ntuple100->findColumn( "hexa11" ), (G4double)   EHEXA11 );
      ntuple100->fill( ntuple100->findColumn( "hexa12" ), (G4double)   EHEXA12 );
      ntuple100->fill( ntuple100->findColumn( "hexa13" ), (G4double)   EHEXA13 );
      ntuple100->fill( ntuple100->findColumn( "hexa14" ), (G4double)   EHEXA14 );
      ntuple100->fill( ntuple100->findColumn( "hexa15" ), (G4double)   EHEXA15 );
      ntuple100->fill( ntuple100->findColumn( "hexa16" ), (G4double)   EHEXA16 );
      ntuple100->fill( ntuple100->findColumn( "hexa17" ), (G4double)   EHEXA17 );
      ntuple100->fill( ntuple100->findColumn( "hexa18" ), (G4double)   EHEXA18 );
      ntuple100->fill( ntuple100->findColumn( "hexa19" ), (G4double)   EHEXA19 );
      ntuple100->fill( ntuple100->findColumn( "hexa20" ), (G4double)   EHEXA20 );
      ntuple100->fill( ntuple100->findColumn( "hexa21" ), (G4double)   EHEXA21 );
      ntuple100->fill( ntuple100->findColumn( "hexa22" ), (G4double)   EHEXA22 );
      ntuple100->fill( ntuple100->findColumn( "hexa23" ), (G4double)   EHEXA23 );
      ntuple100->fill( ntuple100->findColumn( "hexa24" ), (G4double)   EHEXA24 );
      ntuple100->fill( ntuple100->findColumn( "hexa25" ), (G4double)   EHEXA25 );
      ntuple100->fill( ntuple100->findColumn( "hexa26" ), (G4double)   EHEXA26 );
      ntuple100->fill( ntuple100->findColumn( "hexa27" ), (G4double)   EHEXA27 );
      ntuple100->fill( ntuple100->findColumn( "hexa28" ), (G4double)   EHEXA28 );
      ntuple100->fill( ntuple100->findColumn( "hexa29" ), (G4double)   EHEXA29 );
      ntuple100->fill( ntuple100->findColumn( "hexa30" ), (G4double)   EHEXA30 );
      ntuple100->fill( ntuple100->findColumn( "hexa31" ), (G4double)   EHEXA31 );
      ntuple100->fill( ntuple100->findColumn( "hexa32" ), (G4double)   EHEXA32 );
      ntuple100->fill( ntuple100->findColumn( "hexa33" ), (G4double)   EHEXA33 );
      ntuple100->fill( ntuple100->findColumn( "hexa34" ), (G4double)   EHEXA34 );
      ntuple100->fill( ntuple100->findColumn( "hexa35" ), (G4double)   EHEXA35 );
      ntuple100->fill( ntuple100->findColumn( "hexa36" ), (G4double)   EHEXA36 );
      ntuple100->fill( ntuple100->findColumn( "hexa37" ), (G4double)   EHEXA37 );
      ntuple100->fill( ntuple100->findColumn( "hexa38" ), (G4double)   EHEXA38 );
      ntuple100->fill( ntuple100->findColumn( "hexa39" ), (G4double)   EHEXA39 );
      ntuple100->fill( ntuple100->findColumn( "hexa40" ), (G4double)   EHEXA40 );
      ntuple100->fill( ntuple100->findColumn( "hexa41" ), (G4double)   EHEXA41 );
      ntuple100->fill( ntuple100->findColumn( "hexa42" ), (G4double)   EHEXA42 );
      ntuple100->fill( ntuple100->findColumn( "hexa43" ), (G4double)   EHEXA43 );
      ntuple100->fill( ntuple100->findColumn( "hexa44" ), (G4double)   EHEXA44 );
      ntuple100->fill( ntuple100->findColumn( "hexa45" ), (G4double)   EHEXA45 );
      ntuple100->fill( ntuple100->findColumn( "hexa46" ), (G4double)   EHEXA46 );
      ntuple100->fill( ntuple100->findColumn( "hexa47" ), (G4double)   EHEXA47 );
      ntuple100->fill( ntuple100->findColumn( "hexa48" ), (G4double)   EHEXA48 );
      ntuple100->fill( ntuple100->findColumn( "hexa49" ), (G4double)   EHEXA49 );
      ntuple100->fill( ntuple100->findColumn( "hexb_0" ), (G4double)   EHEXB_0 );
      ntuple100->fill( ntuple100->findColumn( "hexb_1" ), (G4double)   EHEXB_1 );
      ntuple100->fill( ntuple100->findColumn( "hexb_2" ), (G4double)   EHEXB_2 );
      ntuple100->fill( ntuple100->findColumn( "hexb_3" ), (G4double)   EHEXB_3 );
      ntuple100->fill( ntuple100->findColumn( "hexb_4" ), (G4double)   EHEXB_4 );
      ntuple100->fill( ntuple100->findColumn( "hexb_5" ), (G4double)   EHEXB_5 );
      ntuple100->fill( ntuple100->findColumn( "hexb_6" ), (G4double)   EHEXB_6 );
      ntuple100->fill( ntuple100->findColumn( "hexb_7" ), (G4double)   EHEXB_7 );
      ntuple100->fill( ntuple100->findColumn( "hexb_8" ), (G4double)   EHEXB_8 );
      ntuple100->fill( ntuple100->findColumn( "hexb_9" ), (G4double)   EHEXB_9 );
      ntuple100->fill( ntuple100->findColumn( "hexb10" ), (G4double)   EHEXB10 );
      ntuple100->fill( ntuple100->findColumn( "hexb11" ), (G4double)   EHEXB11 );
      ntuple100->fill( ntuple100->findColumn( "hexb12" ), (G4double)   EHEXB12 );
      ntuple100->fill( ntuple100->findColumn( "hexb13" ), (G4double)   EHEXB13 );
      ntuple100->fill( ntuple100->findColumn( "hexb14" ), (G4double)   EHEXB14 );
      ntuple100->fill( ntuple100->findColumn( "hexb15" ), (G4double)   EHEXB15 );
      ntuple100->fill( ntuple100->findColumn( "hexb16" ), (G4double)   EHEXB16 );
      ntuple100->fill( ntuple100->findColumn( "hexb17" ), (G4double)   EHEXB17 );
      ntuple100->fill( ntuple100->findColumn( "hexb18" ), (G4double)   EHEXB18 );
      ntuple100->fill( ntuple100->findColumn( "hexb19" ), (G4double)   EHEXB19 );
      ntuple100->fill( ntuple100->findColumn( "hexb20" ), (G4double)   EHEXB20 );
      ntuple100->fill( ntuple100->findColumn( "hexb21" ), (G4double)   EHEXB21 );
      ntuple100->fill( ntuple100->findColumn( "hexb22" ), (G4double)   EHEXB22 );
      ntuple100->fill( ntuple100->findColumn( "hexb23" ), (G4double)   EHEXB23 );
      ntuple100->fill( ntuple100->findColumn( "hexb24" ), (G4double)   EHEXB24 );
      ntuple100->fill( ntuple100->findColumn( "hexb25" ), (G4double)   EHEXB25 );
      ntuple100->fill( ntuple100->findColumn( "hexb26" ), (G4double)   EHEXB26 );
      ntuple100->fill( ntuple100->findColumn( "hexb27" ), (G4double)   EHEXB27 );
      ntuple100->fill( ntuple100->findColumn( "hexb28" ), (G4double)   EHEXB28 );
      ntuple100->fill( ntuple100->findColumn( "hexb29" ), (G4double)   EHEXB29 );
      ntuple100->fill( ntuple100->findColumn( "hexb30" ), (G4double)   EHEXB30 );
      ntuple100->fill( ntuple100->findColumn( "hexb31" ), (G4double)   EHEXB31 );
      ntuple100->fill( ntuple100->findColumn( "hexb32" ), (G4double)   EHEXB32 );
      ntuple100->fill( ntuple100->findColumn( "hexb33" ), (G4double)   EHEXB33 );
      ntuple100->fill( ntuple100->findColumn( "hexb34" ), (G4double)   EHEXB34 );
      ntuple100->fill( ntuple100->findColumn( "hexb35" ), (G4double)   EHEXB35 );
      ntuple100->fill( ntuple100->findColumn( "hexb36" ), (G4double)   EHEXB36 );
      ntuple100->fill( ntuple100->findColumn( "hexb37" ), (G4double)   EHEXB37 );
      ntuple100->fill( ntuple100->findColumn( "hexb38" ), (G4double)   EHEXB38 );
      ntuple100->fill( ntuple100->findColumn( "hexb39" ), (G4double)   EHEXB39 );
      ntuple100->fill( ntuple100->findColumn( "hexb40" ), (G4double)   EHEXB40 );
      ntuple100->fill( ntuple100->findColumn( "hexb41" ), (G4double)   EHEXB41 );
      ntuple100->fill( ntuple100->findColumn( "hexb42" ), (G4double)   EHEXB42 );
      ntuple100->fill( ntuple100->findColumn( "hexb43" ), (G4double)   EHEXB43 );
      ntuple100->fill( ntuple100->findColumn( "hexb44" ), (G4double)   EHEXB44 );
      ntuple100->fill( ntuple100->findColumn( "hexb45" ), (G4double)   EHEXB45 );
      ntuple100->fill( ntuple100->findColumn( "hexb46" ), (G4double)   EHEXB46 );
      ntuple100->fill( ntuple100->findColumn( "hexb47" ), (G4double)   EHEXB47 );
      ntuple100->fill( ntuple100->findColumn( "hexb48" ), (G4double)   EHEXB48 );
      ntuple100->fill( ntuple100->findColumn( "hexb49" ), (G4double)   EHEXB49 );
      ntuple100->fill( ntuple100->findColumn( "hexc_0" ), (G4double)   EHEXC_0 );
      ntuple100->fill( ntuple100->findColumn( "hexc_1" ), (G4double)   EHEXC_1 );
      ntuple100->fill( ntuple100->findColumn( "hexc_2" ), (G4double)   EHEXC_2 );
      ntuple100->fill( ntuple100->findColumn( "hexc_3" ), (G4double)   EHEXC_3 );
      ntuple100->fill( ntuple100->findColumn( "hexc_4" ), (G4double)   EHEXC_4 );
      ntuple100->fill( ntuple100->findColumn( "hexc_5" ), (G4double)   EHEXC_5 );
      ntuple100->fill( ntuple100->findColumn( "hexc_6" ), (G4double)   EHEXC_6 );
      ntuple100->fill( ntuple100->findColumn( "hexc_7" ), (G4double)   EHEXC_7 );
      ntuple100->fill( ntuple100->findColumn( "hexc_8" ), (G4double)   EHEXC_8 );
      ntuple100->fill( ntuple100->findColumn( "hexc_9" ), (G4double)   EHEXC_9 );
      ntuple100->fill( ntuple100->findColumn( "hexc10" ), (G4double)   EHEXC10 );
      ntuple100->fill( ntuple100->findColumn( "hexc11" ), (G4double)   EHEXC11 );
      ntuple100->fill( ntuple100->findColumn( "hexc12" ), (G4double)   EHEXC12 );
      ntuple100->fill( ntuple100->findColumn( "hexc13" ), (G4double)   EHEXC13 );
      ntuple100->fill( ntuple100->findColumn( "hexc14" ), (G4double)   EHEXC14 );
      ntuple100->fill( ntuple100->findColumn( "hexc15" ), (G4double)   EHEXC15 );
      ntuple100->fill( ntuple100->findColumn( "hexc16" ), (G4double)   EHEXC16 );
      ntuple100->fill( ntuple100->findColumn( "hexc17" ), (G4double)   EHEXC17 );
      ntuple100->fill( ntuple100->findColumn( "hexc18" ), (G4double)   EHEXC18 );
      ntuple100->fill( ntuple100->findColumn( "hexc19" ), (G4double)   EHEXC19 );
      ntuple100->fill( ntuple100->findColumn( "hexc20" ), (G4double)   EHEXC20 );
      ntuple100->fill( ntuple100->findColumn( "hexc21" ), (G4double)   EHEXC21 );
      ntuple100->fill( ntuple100->findColumn( "hexc22" ), (G4double)   EHEXC22 );
      ntuple100->fill( ntuple100->findColumn( "hexc23" ), (G4double)   EHEXC23 );
      ntuple100->fill( ntuple100->findColumn( "hexc24" ), (G4double)   EHEXC24 );
      ntuple100->fill( ntuple100->findColumn( "hexc25" ), (G4double)   EHEXC25 );
      ntuple100->fill( ntuple100->findColumn( "hexc26" ), (G4double)   EHEXC26 );
      ntuple100->fill( ntuple100->findColumn( "hexc27" ), (G4double)   EHEXC27 );
      ntuple100->fill( ntuple100->findColumn( "hexc28" ), (G4double)   EHEXC28 );
      ntuple100->fill( ntuple100->findColumn( "hexc29" ), (G4double)   EHEXC29 );
      ntuple100->fill( ntuple100->findColumn( "hexc30" ), (G4double)   EHEXC30 );
      ntuple100->fill( ntuple100->findColumn( "hexc31" ), (G4double)   EHEXC31 );
      ntuple100->fill( ntuple100->findColumn( "hexc32" ), (G4double)   EHEXC32 );
      ntuple100->fill( ntuple100->findColumn( "hexc33" ), (G4double)   EHEXC33 );
      ntuple100->fill( ntuple100->findColumn( "hexc34" ), (G4double)   EHEXC34 );
      ntuple100->fill( ntuple100->findColumn( "hexc35" ), (G4double)   EHEXC35 );
      ntuple100->fill( ntuple100->findColumn( "hexc36" ), (G4double)   EHEXC36 );
      ntuple100->fill( ntuple100->findColumn( "hexc37" ), (G4double)   EHEXC37 );
      ntuple100->fill( ntuple100->findColumn( "hexc38" ), (G4double)   EHEXC38 );
      ntuple100->fill( ntuple100->findColumn( "hexc39" ), (G4double)   EHEXC39 );
      ntuple100->fill( ntuple100->findColumn( "hexc40" ), (G4double)   EHEXC40 );
      ntuple100->fill( ntuple100->findColumn( "hexc41" ), (G4double)   EHEXC41 );
      ntuple100->fill( ntuple100->findColumn( "hexc42" ), (G4double)   EHEXC42 );
      ntuple100->fill( ntuple100->findColumn( "hexc43" ), (G4double)   EHEXC43 );
      ntuple100->fill( ntuple100->findColumn( "hexc44" ), (G4double)   EHEXC44 );
      ntuple100->fill( ntuple100->findColumn( "hexc45" ), (G4double)   EHEXC45 );
      ntuple100->fill( ntuple100->findColumn( "hexc46" ), (G4double)   EHEXC46 );
      ntuple100->fill( ntuple100->findColumn( "hexc47" ), (G4double)   EHEXC47 );
      ntuple100->fill( ntuple100->findColumn( "hexc48" ), (G4double)   EHEXC48 );
      ntuple100->fill( ntuple100->findColumn( "hexc49" ), (G4double)   EHEXC49 );
      ntuple100->fill( ntuple100->findColumn( "hexd_0" ), (G4double)   EHEXD_0 );
      ntuple100->fill( ntuple100->findColumn( "hexd_1" ), (G4double)   EHEXD_1 );
      ntuple100->fill( ntuple100->findColumn( "hexd_2" ), (G4double)   EHEXD_2 );
      ntuple100->fill( ntuple100->findColumn( "hexd_3" ), (G4double)   EHEXD_3 );
      ntuple100->fill( ntuple100->findColumn( "hexd_4" ), (G4double)   EHEXD_4 );
      ntuple100->fill( ntuple100->findColumn( "hexd_5" ), (G4double)   EHEXD_5 );
      ntuple100->fill( ntuple100->findColumn( "hexd_6" ), (G4double)   EHEXD_6 );
      ntuple100->fill( ntuple100->findColumn( "hexd_7" ), (G4double)   EHEXD_7 );
      ntuple100->fill( ntuple100->findColumn( "hexd_8" ), (G4double)   EHEXD_8 );
      ntuple100->fill( ntuple100->findColumn( "hexd_9" ), (G4double)   EHEXD_9 );
      ntuple100->fill( ntuple100->findColumn( "hexd10" ), (G4double)   EHEXD10 );
      ntuple100->fill( ntuple100->findColumn( "hexd11" ), (G4double)   EHEXD11 );
      ntuple100->fill( ntuple100->findColumn( "hexd12" ), (G4double)   EHEXD12 );
      ntuple100->fill( ntuple100->findColumn( "hexd13" ), (G4double)   EHEXD13 );
      ntuple100->fill( ntuple100->findColumn( "hexd14" ), (G4double)   EHEXD14 );
      ntuple100->fill( ntuple100->findColumn( "hexd15" ), (G4double)   EHEXD15 );
      ntuple100->fill( ntuple100->findColumn( "hexd16" ), (G4double)   EHEXD16 );
      ntuple100->fill( ntuple100->findColumn( "hexd17" ), (G4double)   EHEXD17 );
      ntuple100->fill( ntuple100->findColumn( "hexd18" ), (G4double)   EHEXD18 );
      ntuple100->fill( ntuple100->findColumn( "hexd19" ), (G4double)   EHEXD19 );
      ntuple100->fill( ntuple100->findColumn( "hexd20" ), (G4double)   EHEXD20 );
      ntuple100->fill( ntuple100->findColumn( "hexd21" ), (G4double)   EHEXD21 );
      ntuple100->fill( ntuple100->findColumn( "hexd22" ), (G4double)   EHEXD22 );
      ntuple100->fill( ntuple100->findColumn( "hexd23" ), (G4double)   EHEXD23 );
      ntuple100->fill( ntuple100->findColumn( "hexd24" ), (G4double)   EHEXD24 );
      ntuple100->fill( ntuple100->findColumn( "hexd25" ), (G4double)   EHEXD25 );
      ntuple100->fill( ntuple100->findColumn( "hexd26" ), (G4double)   EHEXD26 );
      ntuple100->fill( ntuple100->findColumn( "hexd27" ), (G4double)   EHEXD27 );
      ntuple100->fill( ntuple100->findColumn( "hexd28" ), (G4double)   EHEXD28 );
      ntuple100->fill( ntuple100->findColumn( "hexd29" ), (G4double)   EHEXD29 );
      ntuple100->fill( ntuple100->findColumn( "hexd30" ), (G4double)   EHEXD30 );
      ntuple100->fill( ntuple100->findColumn( "hexd31" ), (G4double)   EHEXD31 );
      ntuple100->fill( ntuple100->findColumn( "hexd32" ), (G4double)   EHEXD32 );
      ntuple100->fill( ntuple100->findColumn( "hexd33" ), (G4double)   EHEXD33 );
      ntuple100->fill( ntuple100->findColumn( "hexd34" ), (G4double)   EHEXD34 );
      ntuple100->fill( ntuple100->findColumn( "hexd35" ), (G4double)   EHEXD35 );
      ntuple100->fill( ntuple100->findColumn( "hexd36" ), (G4double)   EHEXD36 );
      ntuple100->fill( ntuple100->findColumn( "hexd37" ), (G4double)   EHEXD37 );
      ntuple100->fill( ntuple100->findColumn( "hexd38" ), (G4double)   EHEXD38 );
      ntuple100->fill( ntuple100->findColumn( "hexd39" ), (G4double)   EHEXD39 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_0" ), (G4double)   EHH1D_0 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_1" ), (G4double)   EHH1D_1 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_2" ), (G4double)   EHH1D_2 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_3" ), (G4double)   EHH1D_3 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_4" ), (G4double)   EHH1D_4 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_5" ), (G4double)   EHH1D_5 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_6" ), (G4double)   EHH1D_6 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_7" ), (G4double)   EHH1D_7 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_8" ), (G4double)   EHH1D_8 );
      ntuple100->fill( ntuple100->findColumn( "hh1d_9" ), (G4double)   EHH1D_9 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_0" ), (G4double)   EHH2D_0 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_1" ), (G4double)   EHH2D_1 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_2" ), (G4double)   EHH2D_2 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_3" ), (G4double)   EHH2D_3 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_4" ), (G4double)   EHH2D_4 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_5" ), (G4double)   EHH2D_5 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_6" ), (G4double)   EHH2D_6 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_7" ), (G4double)   EHH2D_7 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_8" ), (G4double)   EHH2D_8 );
      ntuple100->fill( ntuple100->findColumn( "hh2d_9" ), (G4double)   EHH2D_9 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_0" ), (G4double)   EVT1V_0 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_1" ), (G4double)   EVT1V_1 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_2" ), (G4double)   EVT1V_2 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_3" ), (G4double)   EVT1V_3 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_4" ), (G4double)   EVT1V_4 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_5" ), (G4double)   EVT1V_5 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_6" ), (G4double)   EVT1V_6 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_7" ), (G4double)   EVT1V_7 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_8" ), (G4double)   EVT1V_8 );
      ntuple100->fill( ntuple100->findColumn( "vt1v_9" ), (G4double)   EVT1V_9 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_0" ), (G4double)   EVT2V_0 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_1" ), (G4double)   EVT2V_1 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_2" ), (G4double)   EVT2V_2 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_3" ), (G4double)   EVT2V_3 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_4" ), (G4double)   EVT2V_4 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_5" ), (G4double)   EVT2V_5 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_6" ), (G4double)   EVT2V_6 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_7" ), (G4double)   EVT2V_7 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_8" ), (G4double)   EVT2V_8 );
      ntuple100->fill( ntuple100->findColumn( "vt2v_9" ), (G4double)   EVT2V_9 );                                                            
      ntuple100->addRow();

  }

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
