//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// Id: PSISteppingAction.cc,v 1.8 2006/01/15 15:38:18 Volnykh V.P. Exp 
// GEANT4 tag Name: geant4-08-00 
//
// 

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#include "PSISteppingAction.hh"
#include "globals.hh"
#include "PSIDetectorConstruction.hh"
#include "PSIEventAction.hh"

#include "G4Track.hh"
#include "G4Step.hh"
#include "G4RunManager.hh"

#include "PSIAnalysis.hh"

////#include "G4RunManager.hh"

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

PSISteppingAction::PSISteppingAction(PSIDetectorConstruction* det,
                                         PSIEventAction* evt)
:detector(det), eventaction(evt)                     
{ }

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

PSISteppingAction::~PSISteppingAction()
{ }

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

void PSISteppingAction::UserSteppingAction(const G4Step* aStep)
{
//   const G4Track* track = aStep->GetTrack();
  //G4VPhysicalVolume* volume = track->GetVolume();
//  G4LogicalVolume* volume = track->GetVolume()->GetLogicalVolume();
  
  // collect energy and track length step by step
  G4double edep = aStep->GetTotalEnergyDeposit();

//  G4double stepl = 0.;
//  if (track->GetDefinition()->GetPDGCharge() != 0.)
//    stepl = aStep->GetStepLength();
      
//  if ((edep!=0.)) {
//    if (volume == detector->GetAbsorber()) eventaction->AddAbs(edep,stepl);
//    if (volume == detector->GetGap())      eventaction->AddGap(edep,stepl);
//  }

//    if (aStep->GetTrack()->GetPosition().x() == "nan pc") {
//       aStep->GetTrack()->SetTrackStatus(fStopAndKill);
// }

  G4int StepNo = aStep->GetTrack()->GetCurrentStepNumber();
  if(StepNo >= 10000) aStep->GetTrack()->SetTrackStatus(fStopAndKill);

#ifdef G4ANALYSIS_USE
  // Do the analysis related to this step
      if ((edep > 0.0)  ||
          (aStep->GetPostStepPoint()->GetProcessDefinedStep()->GetProcessName() == "Decay") ||
	  (aStep->GetPostStepPoint()->GetProcessDefinedStep()->GetProcessName() == "conv"))
    {
       PSIAnalysis* analysis = PSIAnalysis::getInstance();
       analysis->analyseStepping(aStep);
    }

#endif

 // save the random number seed of this event, under condition
 //// if(condition) G4RunManager::GetRunManager()->rndmSaveThisEvent();

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......


}
